/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.Core.Services {
  
  export class AddBundleProductToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    LineActionType? : EVA.Core.LineActionTypes; 
    BundleProductID : number; // Int32
    LineSelection : EVA.Core.Services.AddBundleProductToOrderLineSelection[]; 
  }
  
  export class AddBundleProductToOrderLineSelection {
    ProductBundleLineID : number; // Int32
    SelectedProductID : number; // Int32
    LineSelection : EVA.Core.Services.AddBundleProductToOrderLineSelection[]; 
  }
  
  export class AddDiscountToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    CouponCode : string; 
    DiscountID? : number; // Int32, nullable
    DiscountAmount : number; // Decimal
    // Obsolete
    CurrencyID : string; 
    Reason : string; 
    OrderLines : EVA.Core.OrderLineWithQuantity[]; 
    Password : string; 
    ForceCreate : boolean; 
  }
  
  export class AddInsuranceItemToOrderLine extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    OrderLineID : number; // Int32
    InsuranceItemID : number; // Int32
  }
  
  export class AddLineToPurchaseOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AddLineToPurchaseOrderResponse> {
    OrderID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32
    UnitPrice : number; // Decimal
    RequestedDate? : string; // DateTime, nullable
    Reference : string; 
  }
  
  export class AddLineToPurchaseOrderResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.AddLineToPurchaseOrderResponseModel; 
  }
  
  export class AddProductToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AddProductToOrderResponse> {
    OrderID? : number; // Int32, nullable
    SessionID : string; 
    ForceCreate : boolean; 
    Barcode : string; 
    ProductID? : number; // Int32, nullable
    QuantityOrdered? : number; // Int32, nullable
    LineActionType? : EVA.Core.LineActionTypes; 
    StockLabel : number; // Int32
    CustomOrderLineType : string; 
    ParentID? : number; // Int32, nullable
    ResourceID? : number; // Int32, nullable
    GroupID : string; 
  }
  
  export class AddProductToOrderResponse extends EVA.Core.SimpleShoppingCartResponse {
    // Created or updated OrderLineID
    OrderLineID : number; // Int32
  }
  
  export class AddProductToWishList extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AddProductToWishListResponse> {
    OrderID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32
    SingleProductPerLine : boolean; 
  }
  
  export class AddProductToWishListResponse extends EVA.API.ResponseMessage {
    WishListLineID : number; // Int32
    WishListLineIDs : number[]; 
  }
  
  export class AddPushNotificationDevice extends EVA.API.RequestMessageWithEmptyResponse {
    DeviceToken : string; 
    DeviceOS : string; 
    MobileAppID : string; 
    BackendSystemID : string; 
  }
  
  export class AddressBookDto {
    ID : number; // Int32
    Address : EVA.Core.AddressDto; 
    Description : string; 
    DefaultShippingAddress : boolean; 
    DefaultBillingAddress : boolean; 
  }
  
  export class AddServiceProductToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AddServiceProductToOrderResponse> {
    OrderID? : number; // Int32, nullable
    SessionID : string; 
    ForceCreate : boolean; 
    ProductID : number; // Int32
    Description : string; 
    UnitPriceInTax? : number; // Decimal, nullable
    UnitCost? : number; // Decimal, nullable
    UnitPrice? : number; // Decimal, nullable
  }
  
  export class AddServiceProductToOrderResponse extends EVA.Core.SimpleShoppingCartResponse {
    // Created or updated OrderLineID
    OrderLineID : number; // Int32
  }
  
  export class AddStockResourceToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AddStockResourceToOrderResponse> {
    ResourceID : number; // Int32
    OrderID? : number; // Int32, nullable
    SessionID : string; 
  }
  
  export class AddStockResourceToOrderResponse extends EVA.Core.SimpleShoppingCartResponse {
    // Created or updated OrderLineID
    OrderLineID : number; // Int32
  }
  
  export class AddUserToGroup extends EVA.API.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    GroupID : number; // Int32
  }
  
  export class AddWishListProductToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    WishListOrderID? : number; // Int32, nullable
    TargetOrderID? : number; // Int32, nullable
    AccessToken : string; 
    WishListLines : EVA.Core.Services.AddWishListProductToOrderLine[]; 
    LineActionType? : EVA.Core.LineActionTypes; 
    Name : string; 
    Remark : string; 
  }
  
  export class AddWishListProductToOrderLine {
    WishListLineID : number; // Int32
    Quantity : number; // Int32
  }
  
  export class AdjustStock extends EVA.API.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    SourceLabel : number; // Int32
    Quantity : number; // Int32
    ResourceID? : number; // Int32, nullable
    Reason : number; // Int32
    Remark : string; 
  }
  
  export class ApplicationDto {
    ID : number; // Int32
    Name : string; 
    OrganizationUnitID : number; // Int32
    AuthenticationToken : string; 
    AssetsBaseUrl : string; 
    RequiredUserTypeID? : number; // Int32, nullable
    BaseUrl : string; 
  }
  
  export class ApplyBundleProductLineSelection {
    ProductBundleLineID : number; // Int32
    SelectedProductID : number; // Int32
    LineSelection : EVA.Core.Services.ApplyBundleProductLineSelection[]; 
  }
  
  export class ApplyBundleProductSelection extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    OrderID? : number; // Int32, nullable
    SessionID : string; 
    LineActionType? : EVA.Core.LineActionTypes; 
    BundleProductOrderLineID : number; // Int32
    LineSelection : EVA.Core.Services.ApplyBundleProductLineSelection[]; 
  }
  
  export class ApplySalesTaxEstimateForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SalesTaxEstimateForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export enum ApprovementFailureReasons {
    Unknown = 0,
    AlreadyApproved = 1,
    OrderAlreadyPaid = 2,
  }
  
  export class ApprovePayment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ApprovePaymentResponse> {
    PaymentID : number; // Int32
  }
  
  export class ApprovePaymentResponse extends EVA.API.ResponseMessage {
    HasBeenApproved : boolean; 
    Reason : EVA.Core.Services.ApprovementFailureReasons; 
  }
  
  export class AssignedToUser {
    ID : number; // Int32
    FullName : string; 
    EmailAddress : string; 
  }
  
  export class AttachApplicationToCurrency extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
    ExchangeRate : number; // Decimal
  }
  
  export class AttachBlobToOrder extends EVA.API.RequestMessageWithEmptyResponse {
    BlobID : string; 
    Name : string; 
    OrderID? : number; // Int32, nullable
    OrderLineID? : number; // Int32, nullable
  }
  
  export class AttachCustomerToOrder extends EVA.API.RequestMessageWithEmptyResponse {
    UserID? : number; // Int32, nullable
    OrderID : number; // Int32
  }
  
  export class AttachIdentificationToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AttachIdentificationToOrderResponse> {
    OrderID : number; // Int32
    Type : EVA.Core.IdentificationTypes; 
    Number : string; 
    ValidTo : string; // DateTime
    IssuingDate? : string; // DateTime, nullable
    IssuingCity : string; 
    IssuingCountryID : string; 
    OriginatingCountryID : string; 
    DocumentMimeType : string; 
    Document : string; 
  }
  
  export class AttachIdentificationToOrderResponse extends EVA.API.ResponseMessage {
    IdentificationID : number; // Int32
  }
  
  export class AttachOrderToSession extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
    SessionID : string; 
  }
  
  export class AuthenticateWithThirdPartyLogin extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AuthenticateWithThirdPartyLoginResponse> {
    Code : string; 
    Data : { [ key : string ] : string }; 
  }
  
  export class AuthenticateWithThirdPartyLoginResponse extends EVA.API.ResponseMessage {
    Authentication : EVA.Framework.AuthenticationResults; 
    AuthenticationToken : string; 
  }
  
  export class AutocompleteAddress extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AutocompleteAddressResponse> {
    Query : string; 
  }
  
  export class AutocompleteAddressResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.AddressSuggestion[]; 
  }
  
  export class AutocompleteOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.AutocompleteOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class AutocompleteOrderResponse extends EVA.API.ResponseMessage {
    IsCompleted : boolean; 
  }
  
  export enum AvailabilityTimelineItemTypes {
    CurrentAvailability = 0,
    ExpectedCommitment = 1,
    ExpectedReplenishment = 2,
    ExpectedShipment = 3,
  }
  
  export class BookInvoice extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class ListBrandsPagedResponseBrandDto {
    ID : number; // Int32
    Name : string; 
    BackendID : string; 
  }
  
  export class GetPotentialBundleProductsForOrderResponseBundleProduct {
    BundleProductID : number; // Int32
    BundlePricing : EVA.Core.Services.BundleProductPriceInfo; 
    BundleProductContent : any; 
  }
  
  export class BundleProductContainingProduct {
    BundleProductID : number; // Int32
    BundlePricing : EVA.Core.Services.BundleProductPriceInfo; 
    BundleProductContent : any; 
  }
  
  export class BundleProductLine {
    ID : number; // Int32
    DefaultProductID? : number; // Int32, nullable
    Options : EVA.Core.Services.BundleProductLineOption[]; 
    IsRequired : boolean; 
    IncludedInBundlePrice : boolean; 
    Description : string; 
  }
  
  export class BundleProductLineOption {
    ProductID : number; // Int32
    Lines : EVA.Core.Services.BundleProductLine[]; 
    ProductBundleLineID : number; // Int32
    AdditionalUnitPriceInTax? : number; // Decimal, nullable
    ID : number; // Int32
  }
  
  export class BundleProductPriceInfo {
    UnitPrice : number; // Decimal
    UnitPriceInTax : number; // Decimal
    OriginalUnitPrice? : number; // Decimal, nullable
    OriginalUnitPriceInTax? : number; // Decimal, nullable
    TaxRate : number; // Decimal
    CurrencyID : string; 
  }
  
  export class CancelOrderLine extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CancelOrderLineResponse> {
    OrderLineID : number; // Int32
  }
  
  export class CancelOrderLineResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.OrderCancellationOptions; 
  }
  
  export class CancelWishList extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
  }
  
  export class CardBalanceCheck extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CardBalanceCheckResponse> {
    Barcode : string; 
    CardType : string; 
    CardNumber : string; 
    CardPin : string; 
  }
  
  export class CardBalanceCheckResponse extends EVA.API.ResponseMessage {
    CardID : string; 
    Balance : number; // Decimal
    CurrencyID : string; 
  }
  
  export class GetGiftCardOptionsResponseCardBusinessRules {
    ActivateValues : number[]; 
    ActivateValueMin? : number; // Decimal, nullable
    ActivateValueMax? : number; // Decimal, nullable
    ReloadValueMin? : number; // Decimal, nullable
    ReloadValueMax? : number; // Decimal, nullable
    PurchaseValueMin? : number; // Decimal, nullable
    PurchaseValueMax? : number; // Decimal, nullable
    Reloadable? : boolean; 
    Refundable? : boolean; 
  }
  
  export class CompleteCloseCashJournalCashCorrection {
    Amount : number; // Decimal
    Description : string; 
  }
  
  export class CompleteOpenCashJournalCashCorrection {
    Amount : number; // Decimal
    Description : string; 
  }
  
  export class GetCashExpenseTypesResponseCashExpenseTypeDto {
    ID : number; // Int32
    BackendID : string; 
    Name : string; 
    Description : string; 
    LedgerClassID : string; 
    AmountType : EVA.Core.CashExpenseAmountTypes; 
    OrganizationUnitSet : EVA.Core.Services.CashExpenseTypeOrganizationUnitSet; 
  }
  
  export class CashExpenseTypeOrganizationUnitSet {
    ID : number; // Int32
    Name : string; 
  }
  
  export class GetAvailableCashHandlersResponseCashHandler {
    ID : number; // Int32
    Name : string; 
    CurrencyID : string; 
  }
  
  export class StartOpenCashJournalResponseCashJournal {
    ID : number; // Int32
    OpeningTime : string; // DateTime
    ClosingTime? : string; // DateTime, nullable
    OpeningAmount : number; // Decimal
    ClosingAmount? : number; // Decimal, nullable
  }
  
  export class ChangeUserPassword extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ChangeUserPasswordResponse> {
    UserID : number; // Int32
    NewPassword : string; 
    OldPassword : string; 
  }
  
  export class ChangeUserPasswordResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
    Result : EVA.Framework.PasswordValidationResults; 
  }
  
  export class CheckEmailAddressAvailability extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CheckUsernameAvailabilityResponse> {
    EmailAddress : string; 
  }
  
  export class CheckNicknameAvailability extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CheckUsernameAvailabilityResponse> {
    Nickname : string; 
  }
  
  export class CheckUsernameAvailabilityResponse extends EVA.API.ResponseMessage {
    IsAvailable : boolean; 
    IsValid : boolean; 
    PasswordResetRequired : boolean; 
  }
  
  export class CloseFinancialPeriod extends EVA.API.RequestMessageWithEmptyResponse {
    FinancialPeriodID : number; // Int32
  }
  
  export class MoveCommitmentsCommitmentMovement {
    SourceOrderLineID : number; // Int32
    DestinationOrderLineID : number; // Int32
  }
  
  export class CommitOrderLinesResponseCommitmentResultForOrderLine {
    OrderLineID : number; // Int32
    IsCommitted : boolean; 
  }
  
  export class CommitOrderLines extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CommitOrderLinesResponse> {
    OrderID : number; // Int32
    OrderLineIDs : number[]; 
    CommitmentStatus? : EVA.Core.OrderLineCommitmentStatus; 
  }
  
  export class CommitOrderLinesResponse extends EVA.API.ResponseMessage {
    Results : EVA.Core.Services.CommitOrderLinesResponseCommitmentResultForOrderLine[]; 
  }
  
  export class CompleteCloseCashJournal extends EVA.API.RequestMessageWithEmptyResponse {
    DeviceID : number; // Int32
    Coins : { [ key : number ] : number }; 
    BankNotes : { [ key : number ] : number }; 
    TotalAmount : number; // Decimal
    Corrections : EVA.Core.Services.CompleteCloseCashJournalCashCorrection[]; 
    Data : any; 
  }
  
  export class CompleteOpenCashJournal extends EVA.API.RequestMessageWithEmptyResponse {
    DeviceID : number; // Int32
    Coins : { [ key : number ] : number }; 
    BankNotes : { [ key : number ] : number }; 
    TotalAmount : number; // Decimal
    OpeningDeviationCorrection : EVA.Core.Services.CompleteOpenCashJournalCashCorrection; 
  }
  
  export class ConfigurableGroup {
    ProductID : number; // Int32
    Properties : any; 
    LogicalLevel : string; 
    ConfigurableProperty : string; 
    Value : any; 
    Values : any[]; 
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    Quantity : number; // Int32
    Children : EVA.Core.Services.ConfigurableGroup[]; 
    OrderLines : EVA.Core.Services.ConfigurableOrderLine[]; 
  }
  
  export class ConfigurableOrderLine {
    OrderLineID : number; // Int32
    Quantity : number; // Int32
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
  }
  
  export class ConfirmNewsletterSubscription extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ConfirmNewsletterSubscriptionResponse> {
    Token : string; 
  }
  
  export class ConfirmNewsletterSubscriptionResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
  }
  
  export class ConfirmPurchaseOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    BackendID : string; 
  }
  
  export class ConfirmSubscribe extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ConfirmNewsletterSubscriptionResponse> {
    Token : string; 
    Type : EVA.Core.SubscriptionTypes; 
  }
  
  export class ListShopsInAreaCoordinate {
    Latitude : number; // Double
    Longitude : number; // Double
  }
  
  export class CountryDto {
    ID : string; 
    Name : string; 
  }
  
  export class CreateAccountForIncognitoUser extends EVA.API.RequestMessageWithEmptyResponse {
    Password : string; 
  }
  
  export class CreateAddressBookItem extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    UserID? : number; // Int32, nullable
    Description : string; 
    Address : EVA.Core.AddressDataDto; 
    UseAsDefaultShippingAddress : boolean; 
    UseAsDefaultBillingAddress : boolean; 
  }
  
  export class CreateAnonymousToken extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateAnonymousTokenResponse> {
    OrganizationUnitID : number; // Int32
    LanguageID : string; 
  }
  
  export class CreateAnonymousTokenResponse extends EVA.API.ResponseMessage {
    Token : string; 
  }
  
  export class CreateApiKey extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateApiKeyResponse> {
    UserID : number; // Int32
    ApplicationID? : number; // Int32, nullable
    OrganizationUnitID : number; // Int32
    RequestPermanentApiKey : boolean; 
  }
  
  export class CreateApiKeyResponse extends EVA.API.ResponseMessage {
    ApiKey : string; 
    ExpirationDate? : string; // DateTime, nullable
  }
  
  export class CreateCashDeposit extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    DeviceID : number; // Int32
    Number : string; 
    TotalAmount : number; // Decimal
    Coins : { [ key : number ] : number }; 
    BankNotes : { [ key : number ] : number }; 
  }
  
  export class CreateCashExpense extends EVA.API.RequestMessageWithEmptyResponse {
    DeviceID : number; // Int32
    TypeID : number; // Int32
    Amount : number; // Decimal
    TaxCodeID : number; // Int32
    Description : string; 
  }
  
  export class CreateCashExpenseType extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateCashExpenseTypeResponse> {
    Name : string; 
    Description : string; 
    LedgerClassID : string; 
    BackendID : string; 
    AmountType : EVA.Core.CashExpenseAmountTypes; 
    OrganizationUnitSetID? : number; // Int32, nullable
  }
  
  export class CreateCashExpenseTypeResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreateCompanyForUser extends EVA.API.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Name : string; 
    RegistrationNumber : string; 
    RegistrationCity : string; 
    RegistrationCountryID : string; 
    VatNumber : string; 
    LegalFormID : number; // Int32
    EstablishedDate? : string; // DateTime, nullable
    ContactEmailAddress : string; 
    ContactPhoneNumber : string; 
    AccountHolderName : string; 
    IBAN : string; 
    BIC : string; 
  }
  
  export class CreateCurrency extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
    Name : string; 
  }
  
  export class CreateCustomer extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateCustomerResponse> {
    User : EVA.Core.Services.CustomerDto; 
    SessionID : string; 
    NoAccount : boolean; 
    AutoLogin : boolean; 
  }
  
  export class CreateCustomerResponse extends EVA.API.ResponseMessage {
    User : EVA.Core.LoggedInUserDto; 
    Result : EVA.Core.Services.CreateCustomerResults; 
  }
  
  export enum CreateCustomerResults {
    CreatedCustomer = 0,
    InvalidEmail = 1,
    EmailAlreadyInUse = 3,
    NicknameAlreadyInUse = 4,
    PhoneNumberAlreadyInUse = 5,
    AutoLoginFailed = 6,
  }
  
  export class CreateCustomerWithCompany extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateCustomerWithCompanyResponse> {
    Nickname : string; 
    EmailAddress : string; 
    Gender : string; 
    Initials : string; 
    FirstName : string; 
    LastName : string; 
    PhoneNumber : string; 
    LanguageID : string; 
    CountryID : string; 
    Company : EVA.Core.Services.CustomerCompany; 
  }
  
  export class CreateCustomerWithCompanyResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.CreateCustomerResults; 
  }
  
  export class CreateDevice extends EVA.API.CreateRequest<EVA.Core.DeviceDto> implements EVA.API.IRequestRespondsAs<EVA.API.CreateResponse> {
  }
  
  export class CreateFinancialPeriodAudit extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateFinancialPeriodAuditResponse> {
    OrganizationUnitID : number; // Int32
    Till? : string; // DateTime, nullable
  }
  
  export class CreateFinancialPeriodAuditResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreateInterbranchOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    OrganizationUnitID? : number; // Int32, nullable
  }
  
  export class CreateInvoice extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateInvoiceResponse> {
    OrganizationUnitID : number; // Int32
    SupplierOrganizationUnitID? : number; // Int32, nullable
    PaymentTermStartDate? : string; // DateTime, nullable
    PaymentTermDueDate? : string; // DateTime, nullable
    InvoiceDate : string; // DateTime
    InvoiceNumber : string; 
    Description : string; 
    AdditionalAmounts : EVA.Core.Services.InvoiceAdditionalAmountDto[]; 
    Blobs : EVA.Core.Services.InvoiceBlobDto[]; 
    OriginalTotalAmount? : number; // Decimal, nullable
    Type : EVA.Core.InvoiceTypes; 
    HoldStatusID? : number; // Int32, nullable
    FiscalID : string; 
  }
  
  export class CreateInvoiceResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreateInvoicesForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateInvoicesForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class CreateInvoicesForOrderResponse extends EVA.API.ResponseMessage {
    Invoices : EVA.Core.Services.CreateInvoicesForOrderResponseInvoice[]; 
  }
  
  export class CreateManualInvoice extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateManualInvoiceResponse> {
    OrganizationUnitID : number; // Int32
    Series : string; 
    Number : number; // Int32
    InvoiceDate : string; // DateTime
    Customer : EVA.Core.Services.ManualCustomer; 
    Lines : EVA.Core.Services.ManualLine[]; 
  }
  
  export class CreateManualInvoiceResponse extends EVA.API.ResponseMessage {
    OrderID : number; // Int32
  }
  
  export class CreateOrderFromShoppingCart extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateOrderFromShoppingCartResponse> {
    SessionID : string; 
    CartID? : number; // Int32, nullable
    OrderID? : number; // Int32, nullable
  }
  
  export class CreateOrderFromShoppingCartResponse extends EVA.API.ResponseMessage {
    Order : EVA.Core.OrderDto; 
    TotalAmountInTax : number; // Decimal
    OpenAmount : number; // Decimal
  }
  
  export class CreateOrderLineUnitPriceCorrection extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateOrderLineUnitPriceCorrectionResponse> {
    OrderID : number; // Int32
    OrderLineID : number; // Int32
    UnitPrice? : number; // Decimal, nullable
    IncludingTax : boolean; 
  }
  
  export class CreateOrderLineUnitPriceCorrectionResponse extends EVA.API.GetResponse<EVA.Core.OrderLineDto> {
  }
  
  export class CreateOrganizationOpeningHours extends EVA.API.CreateRequest<EVA.Core.OpeningHoursDto> implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
    OpeningHoursDto : EVA.Core.OpeningHoursDto[]; 
  }
  
  export class CreateOrganizationUnit extends EVA.API.CreateRequest<EVA.Core.OrganizationUnitDto> implements EVA.API.IRequestRespondsAs<EVA.API.CreateResponse> {
  }
  
  export class CreateOrganizationUnitSupplier extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    OrganizationUnitID? : number; // Int32, nullable
    SupplierOrganizationUnitID : number; // Int32
    Type : EVA.Core.OrganizationUnitSupplierTypes; 
  }
  
  export class CreatePayment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreatePaymentResponse> {
    OrderID : number; // Int32
    PaymentTypeID? : number; // Int32, nullable
    Amount? : number; // Decimal, nullable
    Properties : any; 
    Code : string; 
  }
  
  export class CreatePaymentResponse extends EVA.API.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto; 
    PaymentTransactions : EVA.Core.PaymentTransactionDto[]; 
    OpenAmount : number; // Decimal
    Properties : any; 
  }
  
  export class CreateProductAvailabilityData extends EVA.API.CreateRequest<EVA.Core.ProductAvailabilityDataDto> implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class CreateProductBundle extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    BackendID : string; 
    BundleProductID : number; // Int32
    Lines : EVA.Core.Services.CreateProductBundleLine[]; 
  }
  
  export class CreateProductBundleLine {
    DefaultProductID? : number; // Int32, nullable
    Description : string; 
    BackendID : string; 
    Type : EVA.Core.ProductBundleLineTypes; 
    Options : EVA.Core.Services.CreateProductBundleLineOption[]; 
  }
  
  export class CreateProductBundleLineOption {
    ProductID : number; // Int32
  }
  
  export class CreateProductRequirement extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateProductRequirementResponse> {
    ProductID : number; // Int32
    Name : string; 
    DataType : EVA.Core.ProductRequirementDataTypes; 
    IsArray : boolean; 
    IsRequired : boolean; 
    Data : any; 
  }
  
  export class CreateProductRequirementResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreateProductStructure extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateProductStructureResponse> {
    Code : string; 
    Name : string; 
    LanguageID : string; 
    CountryID : string; 
    Definition : EVA.Core.ProductStructureDefinition; 
  }
  
  export class CreateProductStructureResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreatePurchaseOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreatePurchaseOrderResponse> {
    OrganizationUnitID : number; // Int32
    SupplierID? : number; // Int32, nullable
    BackendID : string; 
  }
  
  export class CreatePurchaseOrderResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
    ID : number; // Int32
  }
  
  export class CreateRecurringTask extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
    FullName : string; 
    Cron : string; 
    Arguments : { [ key : string ] : string }; 
  }
  
  export class CreateReturnToSupplierOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
  }
  
  export class CreateStation extends EVA.API.CreateRequest<EVA.Core.StationDto> implements EVA.API.IRequestRespondsAs<EVA.API.CreateResponse> {
  }
  
  export class CreateStockAllocationRule extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    OrganizationUnitSupplierID : number; // Int32
    OrganizationUnitID? : number; // Int32, nullable
    ProductID? : number; // Int32, nullable
    Value : number; // Int32
    ValueType : EVA.Core.StockAllocationRuleValueTypes; 
    RefillPeriodInDays? : number; // Int32, nullable
    Type : EVA.Core.StockAllocationRuleTypes; 
    ProductIDs : number[]; 
  }
  
  export class CreateStockNotification extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StockNotificationResponse> {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    EmailAddress : string; 
    CountryID : string; 
    LanguageID : string; 
  }
  
  export class CreateStockNotificationForCurrentUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StockNotificationResponse> {
    ProductID : number; // Int32
    OrganizationUnitID? : number; // Int32, nullable
    CountryID : string; 
    LanguageID : string; 
  }
  
  export class CreateStockResource extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateStockResourceResponse> {
    Resources : { [ key : string ] : string }; 
  }
  
  export class CreateStockResourceResponse extends EVA.API.ResponseMessage {
    ResourceID : number; // Int32
  }
  
  export class CreateTaxRate extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    CountryID : string; 
    TaxCodeID : number; // Int32
    Rate : number; // Decimal
    StartDate? : string; // DateTime, nullable
    EndDate? : string; // DateTime, nullable
  }
  
  export class CreateUserGroup extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    Name : string; 
  }
  
  export class CreateUserPhoneNumber extends EVA.API.RequestMessageGeneric<EVA.API.CreateResponse> {
    UserID? : number; // Int32, nullable
    PhoneNumber : string; 
    Type : EVA.Core.PhoneNumberTypes; 
    Description : string; 
    IsPrimary : boolean; 
  }
  
  export class CreateWishList extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateWishListResponse> {
    Name : string; 
    Data : any; 
  }
  
  export class CreateWishListFromShoppingCart extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateWishListFromShoppingCartResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Name : string; 
    Data : any; 
  }
  
  export class CreateWishListFromShoppingCartResponse extends EVA.API.ResponseMessage {
    OrderID : number; // Int32
    AccessToken : string; 
  }
  
  export class CreateWishListPayment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreateWishListPaymentResponse> {
    OrderID : number; // Int32
    AccessToken : string; 
    Code : string; 
    Amount : number; // Decimal
    Properties : any; 
    Name : string; 
    Remark : string; 
    Lines : EVA.Core.Services.CreateWishListPaymentLine[]; 
  }
  
  export class CreateWishListPaymentLine {
    WishListLineID : number; // Int32
    Amount : number; // Decimal
  }
  
  export class CreateWishListPaymentResponse extends EVA.API.ResponseMessage {
    PaymentTransaction : EVA.Core.Services.WishListPaymentTransactionDto; 
    OpenAmount : number; // Decimal
    Properties : any; 
  }
  
  export class CreateWishListResponse extends EVA.API.ResponseMessage {
    OrderID : number; // Int32
    AccessToken : string; 
  }
  
  export class CurrencyDto {
    ID : string; 
    Name : string; 
    ExchangeRate : number; // Decimal
    IsBaseCurrency : boolean; 
  }
  
  export class CustomerCompany {
    Name : string; 
    RegistrationNumber : string; 
    RegistrationCity : string; 
    RegistrationCountryID : string; 
    VatNumber : string; 
    LegalForm : EVA.Core.LegalForms; 
    EstablishedDate? : string; // DateTime, nullable
    VisitorsAddress : EVA.Core.AddressDataDto; 
    DeliveryAddress : EVA.Core.AddressDataDto; 
    ReturnsAddress : EVA.Core.AddressDataDto; 
    InvoiceAddress : EVA.Core.AddressDataDto; 
    InvoiceEmailAddress : string; 
    ContactEmailAddress : string; 
    ContactPhoneNumber : string; 
    AccountHolderName : string; 
    IBAN : string; 
    BIC : string; 
    LogoID : string; 
  }
  
  export class CustomerDto {
    EmailAddress : string; 
    Gender : string; 
    Initials : string; 
    FirstName : string; 
    LastName : string; 
    PhoneNumber : string; 
    SubscriptionType : EVA.Core.SubscriptionTypes; 
    DateOfBirth? : string; // DateTime, nullable
    PlaceOfBirth : string; 
    BankAccount : string; 
    Nickname : string; 
    Password : string; 
    LanguageID : string; 
    CountryID : string; 
    FiscalID : string; 
    SocialSecurityNumber : string; 
    OriginID? : number; // Int32, nullable
    ShippingAddress : EVA.Core.AddressDataDto; 
    BillingAddress : EVA.Core.AddressDataDto; 
  }
  
  export class DeleteAddressBookItem extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteCashDeposit extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteCashExpense extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteCashExpenseType extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteCurrency extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
  }
  
  export class DeleteDevice extends EVA.API.DeleteRequest implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class DeleteEntityTranslation extends EVA.API.RequestMessageWithEmptyResponse {
    EntityID : number; // Int32
    EntityType : string; 
    EntityField : string; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class DeleteOrganizationOpeningHours extends EVA.API.DeleteRequest implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class DeleteOrganizationUnit extends EVA.API.RequestMessageWithEmptyResponse {
    OrganizationUnitID : number; // Int32
  }
  
  export class DeleteOrganizationUnitSupplier extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteProductAvailabilityData extends EVA.API.DeleteRequest implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class DeleteProductBundle extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteProductRequirement extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteProductStructure extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteRecurringTask extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
  }
  
  export class DeleteStation extends EVA.API.DeleteRequest implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class DeleteStationByProxyID extends EVA.API.RequestMessage implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
    ProxyID : string; 
  }
  
  export class DeleteStockAllocationRule extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteStockNotification extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    ID : number; // Int32
    EmailAddress : string; 
  }
  
  export class DeleteStringTranslation extends EVA.API.RequestMessageWithEmptyResponse {
    Key : string; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class DeleteTaxRate extends EVA.API.DeleteRequest implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class DeleteUser extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteUserGroup extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DeleteUserPhoneNumber extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DetachApplicationFromCurrency extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
  }
  
  export class DetachCompanyFromUser extends EVA.API.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
  }
  
  export class DetachCustomerFromOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
  }
  
  export class DetachOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.DetachOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class DetachOrderFromSession extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
  }
  
  export class DetachOrderResponse extends EVA.API.ResponseMessage {
    ReminderToken : string; 
  }
  
  export enum DocumentTypes {
    Order = 0,
    Quote = 1,
    Invoice = 2,
    ReturnToSupplier = 3,
    Interbranch = 4,
  }
  
  export class DownloadFinancialPeriodDeposit extends EVA.API.RequestMessageGeneric<EVA.API.ResourceResponseMessage> {
    FinancialPeriodID : number; // Int32
  }
  
  export class DuplicateOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.DuplicateOrderResponse> {
    OrderID : number; // Int32
    OrderLineIDs : number[]; 
    OrganizationUnitID? : number; // Int32, nullable
  }
  
  export class DuplicateOrderResponse extends EVA.API.ResponseMessage {
    DuplicatedOrderID : number; // Int32
  }
  
  export class EditProductStructure extends EVA.API.RequestMessageGeneric<EVA.Core.Services.EditProductStructureResponse> {
    ID : number; // Int32
    Code : string; 
    Name : string; 
    LanguageID : string; 
    CountryID : string; 
    Definition : EVA.Core.ProductStructureDefinition; 
  }
  
  export class EditProductStructureResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class EnqueueTask extends EVA.API.RequestMessageWithEmptyResponse {
    FullName : string; 
    Arguments : { [ key : string ] : string }; 
  }
  
  export class EnrollSidekick extends EVA.API.RequestMessageWithEmptyResponse {
    SidekickID : string; 
  }
  
  export class ListEnumValuesResponseEnumValue {
    Name : string; 
    Value : number; // Int32
    Description : string; 
  }
  
  export class ExemptOrderFromTax extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    // A short (max 10 characters) identifying the tax exemption.
    TaxExemptionCode : string; 
    // A longer description with the justification for the tax exemption.
    TaxExemptionReason : string; 
  }
  
  export class ListExternalOrderStatusForOrderResponseExternalOrderStatus {
    Name : string; 
    Status : string; 
    CanPollStatus : boolean; 
  }
  
  export class FeedSubscriptionDto {
    ID : number; // Int32
    Name : string; 
    WebhookUrl : string; 
  }
  
  export class FinalizePayment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.FinalizePaymentResponse> {
    PaymentTransactionID : number; // Int32
    Amount? : number; // Decimal, nullable
  }
  
  export class FinalizePaymentResponse extends EVA.API.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto; 
    OpenAmount : number; // Decimal
  }
  
  export class FinancialPeriodBlobDto {
    FinancialPeriodID : number; // Int32
    Name : string; 
    MimeType : string; 
    BlobID : string; 
  }
  
  export class GetFinancialPeriodInformationResponseFinancialPeriodOrganizationUnit {
    ID : number; // Int32
    Name : string; 
  }
  
  export class FindStockResource extends EVA.API.RequestMessageGeneric<EVA.Core.Services.FindStockResourceResponse> {
    Type : string; 
    Value : string; 
  }
  
  export class FindStockResourceResponse extends EVA.API.ResponseMessage {
    Resource : EVA.Core.Services.StockResourceDto; 
  }
  
  export class FlushCache extends EVA.API.RequestMessageWithEmptyResponse {
    Pattern : string; 
  }
  
  export class ForcePlaceOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ForcePlaceOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class ForcePlaceOrderResponse extends EVA.API.ResponseMessage {
    ValidationResult : EVA.Core.OrderExportValidationResult; 
  }
  
  export class FullyReceiveDeliveryNoteNumber extends EVA.API.RequestMessageGeneric<EVA.Core.Services.FullyReceiveDeliveryNoteNumberResponse> {
    DeliveryNoteNumber : string; 
  }
  
  export class FullyReceiveDeliveryNoteNumberResponse extends EVA.API.ResponseMessage {
    ReservedOrdersCount : number; // Int32
  }
  
  export class FullyReceiveShipment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.FullyReceiveShipmentResponse> {
    BackendID : string; 
  }
  
  export class FullyReceiveShipmentResponse extends EVA.API.ResponseMessage {
    ReservedOrdersCount : number; // Int32
  }
  
  export class FullyShipPurchaseOrder extends EVA.API.RequestMessageWithEmptyResponse {
    PurchaseOrderID : number; // Int32
    ShipmentBackendID : string; 
    BackendSystemID : string; 
    TrackingCode : string; 
  }
  
  export class GetAvailableServiceDetailsResponseFunctionalityInfo {
    Functionality : string; 
    Scope : EVA.Framework.FunctionalityScope; 
  }
  
  export class ListGeneralLedgersResponseGeneralLedger {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    OrganizationUnit : EVA.Core.Services.ListGeneralLedgersResponseOrganizationUnit; 
    FinancialPeriodID : number; // Int32
    Amount : number; // Decimal
    Remark : string; 
    PaymentTransactionID? : number; // Int32, nullable
    CreationTime : string; // DateTime
    OrderID? : number; // Int32, nullable
    AccountName : string; 
    AccountObjectAccount : string; 
    StockMutationID? : number; // Int32, nullable
    CurrencyID : string; 
  }
  
  export class GenerateDeviceHubBarcode extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GenerateDeviceHubBarcodeResponse> {
  }
  
  export class GenerateDeviceHubBarcodeResponse extends EVA.API.ResponseMessage {
    DeviceID : string; 
    Barcode : string; 
  }
  
  export class GenerateEnrollmentToken extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GenerateEnrollmentTokenResponse> {
    OrganizationUnitID : number; // Int32
  }
  
  export class GenerateEnrollmentTokenResponse extends EVA.API.ResponseMessage {
    Token : string; 
  }
  
  export class GenerateScanModeBarcode extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GenerateScanModeBarcodeResponse> {
  }
  
  export class GenerateScanModeBarcodeResponse extends EVA.API.ResponseMessage {
    DeviceID : string; 
    Barcode : string; 
  }
  
  export class GenerateSessionBarcode extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GenerateSessionBarcodeResponse> {
    OrderID : number; // Int32
  }
  
  export class GenerateSessionBarcodeResponse extends EVA.API.ResponseMessage {
    Barcode : string; 
  }
  
  export class GenerateTemporaryPasswordForUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GenerateTemporaryPasswordForUserResponse> {
    UserID : number; // Int32
  }
  
  export class GenerateTemporaryPasswordForUserResponse extends EVA.API.ResponseMessage {
    Password : string; 
  }
  
  export class GetActivePaymentTypes extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetActivePaymentTypesResponse> {
  }
  
  export class GetActivePaymentTypesResponse extends EVA.API.ResponseMessage {
    Result : string[]; 
  }
  
  export class GetAddressForZipCode extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAddressForZipCodeResponse> {
    ZipCode : string; 
    HouseNumber : string; 
  }
  
  export class GetAddressForZipCodeResponse extends EVA.API.GetResponse<EVA.Core.AddressDataDto> {
  }
  
  export class GetAnonymousToken extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAnonymousTokenResponse> {
    OrganizationUnitID : number; // Int32
    LanguageID : string; 
  }
  
  export class GetAnonymousTokenResponse extends EVA.API.ResponseMessage {
    Token : string; 
  }
  
  export class GetApplicationConfiguration extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetApplicationConfigurationResponse> {
  }
  
  export class GetApplicationConfigurationResponse extends EVA.API.ResponseMessage {
    Configuration : { [ key : string ] : any }; 
  }
  
  export class GetAutocompleteAddressByReference extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAutocompleteAddressByReferenceResponse> {
    Suggestion : EVA.Core.AddressSuggestion; 
  }
  
  export class GetAutocompleteAddressByReferenceResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.AddressSuggestionDetails; 
  }
  
  export class GetAvailabilityIndication extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailabilityIndicationResponse> {
    OrganizationUnitID? : number; // Int32, nullable
    // Providing this will limit the pickup availability indication to only these OrganizationUnits.
    PickupOrganizationUnitIDs : number[]; 
    // The products for which to retrieve the availability.<br />The QuantityRequested will default to 1 if not provided.
    Products : EVA.Core.ProductQuantityDto[]; 
    // If true, limits the pickup availability results to only the OrganizationUnit<br />that has the product available the quickest. If multiple OrganizationUnits have the same availability, it's not defined<br />which OrganizationUnit is returned.
    FastestPickupShopOnly? : boolean; 
    // If true, the OrganizationUnits returned not only have their basic information returned, but also their OpeningHours.
    DetailedShopInformation : boolean; 
    IncludeAvailabilityTexts : boolean; 
    // If provided, limits the availability to indication to the provided types.<br />The types can be combined to provide both Delivery and Pickup indications, but this is also the default behavior<br />so specifying this is not necessary. Specify this only if you only need either Delivery or Pickup indications,<br />this can result in better performance due to a smaller response size.
    Type? : EVA.Core.GetAvailabilityTypes; 
  }
  
  export class GetAvailabilityIndicationResponse extends EVA.API.ResponseMessage {
    Products : EVA.Core.ProductAvailabilityIndication[]; 
  }
  
  export class GetAvailableCashHandlers extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailableCashHandlersResponse> {
    CurrencyID : string; 
  }
  
  export class GetAvailableCashHandlersResponse extends EVA.API.ResponseMessage {
    Handlers : EVA.Core.Services.GetAvailableCashHandlersResponseCashHandler[]; 
  }
  
  export class GetAvailableCurrencies extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailableCurrenciesResponse> {
  }
  
  export class GetAvailableCurrenciesResponse extends EVA.API.ResponseMessage {
    Currencies : EVA.Core.Services.CurrencyDto[]; 
  }
  
  export class GetAvailablePaymentMethods extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailablePaymentMethodsResponse> {
    OrderID? : number; // Int32, nullable
  }
  
  export class GetAvailablePaymentMethodsResponse extends EVA.API.ResponseMessage {
    PaymentMethods : string[]; 
    Results : EVA.Core.Services.GetAvailablePaymentMethodsResponseMethodModel[]; 
  }
  
  export class GetAvailableRefundPaymentMethods extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailableRefundPaymentMethodsResponse> {
    UserID : number; // Int32
    CurrencyID : string; 
  }
  
  export class GetAvailableRefundPaymentMethodsResponse extends EVA.API.ResponseMessage {
    Methods : EVA.Core.Services.GetAvailableRefundPaymentMethodsResponsePaymentMethod[]; 
  }
  
  export class GetAvailableServiceDetails extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailableServiceDetailsResponse> {
    Type : string; 
  }
  
  export class GetAvailableServiceDetailsResponse extends EVA.API.ResponseMessage {
    Description : string; 
    Request : EVA.Core.Services.GetAvailableServiceDetailsResponseTypeDefinition; 
    Response : EVA.Core.Services.GetAvailableServiceDetailsResponseTypeDefinition; 
    Routes : EVA.Core.Services.GetAvailableServiceDetailsResponseRoute[]; 
    Security : EVA.Core.Services.GetAvailableServiceDetailsResponseSecurityInfo; 
    AvailableInSidekickMode : boolean; 
  }
  
  export class GetAvailableServices extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailableServicesResponse> {
  }
  
  export class GetAvailableServicesResponse extends EVA.API.ResponseMessage {
    Services : EVA.Core.Services.GetAvailableServicesResponseService[]; 
  }
  
  export class GetAvailableThirdPartiesForLogin extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetAvailableThirdPartiesForLoginResponse> {
  }
  
  export class GetAvailableThirdPartiesForLoginResponse extends EVA.API.ResponseMessage {
    AuthenticationMethods : string[]; 
  }
  
  export class GetBundleProductDetailResponse extends EVA.API.ResponseMessage {
    Lines : EVA.Core.Services.BundleProductLine[]; 
    BundleProductID : number; // Int32
    Products : EVA.Core.Services.GetBundleProductProduct[]; 
  }
  
  export class GetBundleProductDetails extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetBundleProductDetailResponse> {
    BundleProductID : number; // Int32
    IncludedFields : string[]; 
  }
  
  export class GetBundleProductProduct {
    ID : number; // Int32
    CustomID : string; 
    Type : EVA.Core.ProductTypes; 
    Content : any; 
    Pricing : EVA.Core.Services.BundleProductPriceInfo; 
  }
  
  export class GetBundleProductsForProduct extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetBundleProductsForProductResponse> {
    ProductID : number; // Int32
    IncludedFields : string[]; 
  }
  
  export class GetBundleProductsForProductResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.BundleProductContainingProduct[]; 
  }
  
  export class GetCashExpenseTypeByID extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCashExpenseTypeByIDResponse> {
    ID : number; // Int32
  }
  
  export class GetCashExpenseTypeByIDResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    BackendID : string; 
    Name : string; 
    Description : string; 
    LedgerClassID : string; 
    AmountType : EVA.Core.CashExpenseAmountTypes; 
    OrganizationUnitSet : EVA.Core.Services.CashExpenseTypeOrganizationUnitSet; 
  }
  
  export class GetCashExpenseTypes extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCashExpenseTypesResponse> {
    OrganizationUnitID? : number; // Int32, nullable
  }
  
  export class GetCashExpenseTypesResponse extends EVA.API.ResponseMessage {
    CashExpenseTypes : EVA.Core.Services.GetCashExpenseTypesResponseCashExpenseTypeDto[]; 
  }
  
  export class GetCashJournalDenominations extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCashJournalDenominationsResponse> {
    DeviceID : number; // Int32
  }
  
  export class GetCashJournalDenominationsResponse extends EVA.API.ResponseMessage {
    CurrencyID : string; 
    AvailableCoins : number[]; 
    AvailableBankNotes : number[]; 
  }
  
  export class GetCompanyForUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCompanyForUserResponse> {
    UserID : number; // Int32
  }
  
  export class GetCompanyForUserResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.CompanyDto; 
  }
  
  export class GetConfigurableOrderView extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetConfigurableOrderViewResponse> {
    OrderID : number; // Int32
    LogicalLevel : string; 
    GroupByPropertyType : string; 
    IncludeAllChildren : boolean; 
    ProductProperties : string[]; 
  }
  
  export class GetConfigurableOrderViewResponse extends EVA.API.ResponseMessage {
    PropertyGroups : EVA.Core.Services.PropertyGroup[]; 
    OtherLines : { [ OrderLineTypes : number ] : EVA.Core.Services.SimpleOrderLine[] }; 
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
  }
  
  export class GetConfigurableProductDetail extends EVA.API.GetRequestGeneric<EVA.Core.Services.GetConfigurableProductDetailResponse> {
    Includes : string[]; 
  }
  
  export class GetConfigurableProductDetailResponse extends EVA.API.ResponseMessage {
    Configurable : EVA.Core.ConfigurableProductDto; 
  }
  
  export class GetConfigurableProductsDetail extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetConfigurableProductsDetailResponse> {
    ProductIDs : number[]; 
    Includes : string[]; 
  }
  
  export class GetConfigurableProductsDetailResponse extends EVA.API.ResponseMessage {
    Configurables : { [ key : number ] : EVA.Core.ConfigurableProductDto }; 
  }
  
  export class GetContractNumber extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetContractNumberResponse> {
    OrderLineID : number; // Int32
  }
  
  export class GetContractNumberResponse extends EVA.API.ResponseMessage {
    ContractNumber : string; 
  }
  
  export class GetCurrency extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCurrencyResponse> {
    ID : string; 
  }
  
  export class GetCurrencyResponse extends EVA.API.ResponseMessage {
    ID : string; 
    Name : string; 
  }
  
  export class GetCurrentApplication extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCurrentApplicationResponse> {
  }
  
  export class GetCurrentApplicationResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    Name : string; 
    OrganizationUnitID : number; // Int32
    // Obsolete: Please use the ApplicationConfiguration property instead
    AssetsBaseUrl : string; 
    RequiredUserTypeID? : number; // Int32, nullable
    // Obsolete: Please use the ApplicationConfiguration property instead
    BaseUrl : string; 
  }
  
  export class GetCurrentFinancialPeriodSummary extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCurrentFinancialPeriodSummaryResponse> {
  }
  
  export class GetCurrentFinancialPeriodSummaryResponse extends EVA.API.ResponseMessage {
    FinancialPeriodID : number; // Int32
    FinancialPeriodStatus : EVA.Core.FinancialPeriodStatus; 
  }
  
  export class GetCurrentUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetCurrentUserResponse> {
  }
  
  export class GetCurrentUserResponse extends EVA.API.ResponseMessage {
    User : EVA.Core.LoggedInUserDto; 
  }
  
  export class GetDeliveryOrderData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetDeliveryOrderDataResponse> {
    OrderID : number; // Int32
  }
  
  export class GetDeliveryOrderDataResponse extends EVA.API.ResponseMessage {
    DeliveryOrderData : EVA.Core.DeliveryOrderData; 
  }
  
  export class GetDevice extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetDeviceResponse> {
    ID : number; // Int32
  }
  
  export class GetDeviceResponse extends EVA.API.GetResponse<EVA.Core.DeviceDto> {
  }
  
  export class GetEmailAddressDomainSuggestions extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetEmailAddressDomainSuggestionsResponse> {
    // The number of suggestions to return. Defaults to 5 and is limited to 10.
    MaxSuggestions? : number; // Int32, nullable
  }
  
  export class GetEmailAddressDomainSuggestionsResponse extends EVA.API.ResponseMessage {
    // A list of the domain names, ordered by usage count. Each domain is returned in the form of `domain.tld`.
    Domains : string[]; 
  }
  
  export class GetEntityTranslation extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetEntityTranslationResponse> {
    EntityID : number; // Int32
    EntityType : string; 
    EntityField : string; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class GetEntityTranslationResponse extends EVA.API.ResponseMessage {
    EntityID : number; // Int32
    EntityType : string; 
    EntityField : string; 
    LanguageID : string; 
    CountryID : string; 
    Value : string; 
  }
  
  export class GetFinancialPeriodAccountsSummary extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetFinancialPeriodAccountsSummaryResponse> {
    FinancialPeriodID : number; // Int32
  }
  
  export class GetFinancialPeriodAccountsSummaryResponse extends EVA.API.ResponseMessage {
    Accounts : EVA.Core.AccountSummary[]; 
  }
  
  export class GetFinancialPeriodClosingImpediments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetFinancialPeriodClosingImpedimentsResponse> {
    FinancialPeriodID : number; // Int32
  }
  
  export class GetFinancialPeriodClosingImpedimentsResponse extends EVA.API.ResponseMessage {
    Impediments : EVA.Core.FinancialPeriodClosingImpediment[]; 
  }
  
  export class GetFinancialPeriodDetails extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetFinancialPeriodDetailsResponse> {
    FinancialPeriodID : number; // Int32
  }
  
  export class GetFinancialPeriodDetailsResponse extends EVA.API.ResponseMessage {
    Details : EVA.Core.FinancialPeriodDetailsDto; 
  }
  
  export class GetFinancialPeriodExportDocuments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetFinancialPeriodExportDocumentsResponse> {
    ID : number; // Int32
  }
  
  export class GetFinancialPeriodExportDocumentsResponse extends EVA.API.ResponseMessage {
    RequestDocuments : EVA.Core.TransputJobDocument[]; 
    ResponseDocuments : EVA.Core.TransputJobDocument[]; 
  }
  
  export class GetFinancialPeriodInformation extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetFinancialPeriodInformationResponse> {
    // If left null, defaults to the current period of the logged in user.
    FinancialPeriodID? : number; // Int32, nullable
  }
  
  export class GetFinancialPeriodInformationResponse extends EVA.API.ResponseMessage {
    FinancialPeriodID : number; // Int32
    Status : EVA.Core.FinancialPeriodStatus; 
    CashJournals : EVA.Core.CashJournalDetailsModel[]; 
    PaymentTypeSummaries : EVA.Core.Services.GetFinancialPeriodInformationResponsePaymentTypeSummary[]; 
    OrganizationUnit : EVA.Core.Services.GetFinancialPeriodInformationResponseFinancialPeriodOrganizationUnit; 
  }
  
  export class GetFiscalOrderData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetFiscalOrderDataResponse> {
    OrderID : number; // Int32
  }
  
  export class GetFiscalOrderDataResponse extends EVA.API.ResponseMessage {
    FiscalID : string; 
    VatNumber : string; 
  }
  
  export class GetFlatOrganizationUnitTree extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetFlatOrganizationUnitTreeResponse> {
    OrganizationUnitID : number; // Int32
  }
  
  export class GetFlatOrganizationUnitTreeResponse extends EVA.API.ResponseMessage {
    OrganizationUnits : EVA.Core.Services.GetFlatOrganizationUnitTreeResponseOrganizationUnitDto[]; 
  }
  
  export class GetGiftCardOptions extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetGiftCardOptionsResponse> {
    ProductID : number; // Int32
    CardNumber : string; 
  }
  
  export class GetGiftCardOptionsResponse extends EVA.API.ResponseMessage {
    CardID : string; 
    Status : string; 
    CurrencyID : string; 
    BusinessRules : EVA.Core.Services.GetGiftCardOptionsResponseCardBusinessRules; 
  }
  
  export class GetGiftWrappingOptionsForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetGiftWrappingOptionsForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class GetGiftWrappingOptionsForOrderResponse extends EVA.API.ResponseMessage {
    WrapOrder : boolean; 
    WrapIndividually : boolean; 
    // Obsolete: replaced with GiftWraps
    Lines : EVA.Core.Services.WrapLine[]; 
    GiftWraps : EVA.Core.Services.GiftWrap[]; 
  }
  
  export class GetInvoice extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetInvoiceResponse> {
    ID : number; // Int32
  }
  
  export class GetInvoiceResponse extends EVA.API.ResponseMessage {
    Invoice : EVA.Core.Services.InvoiceDetailsDto; 
  }
  
  export class GetOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrderResponse> {
    OrderID : number; // Int32
    IncludeFailedPayments : boolean; 
    IncludePendingPayments : boolean; 
    ProductProperties : string[]; 
    ShowOnlyShippableLines : boolean; 
  }
  
  export class GetOrderExportByID extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrderExportByIDResponse> {
    ID : number; // Int32
  }
  
  export class GetOrderExportByIDResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    OrderID : number; // Int32
    Name : string; 
    Status : EVA.Core.TransputJobStatuses; 
    IsDelivery : boolean; 
    ShipFromOrganizationUnitID? : number; // Int32, nullable
    ShipFromOrganizationUnitName : string; 
    ShipToOrganizationUnitID : number; // Int32
    ShipToOrganizationUnitName : string; 
    Lines : EVA.Core.Services.GetOrderExportByIDResponseOrderExportLineDto[]; 
    CreationTime : string; // DateTime
    LastModificationTime? : string; // DateTime, nullable
  }
  
  export class GetOrderExportDocuments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrderExportDocumentsResponse> {
    ID : number; // Int32
  }
  
  export class GetOrderExportDocumentsResponse extends EVA.API.ResponseMessage {
    RequestDocuments : EVA.Core.TransputJobDocument[]; 
    ResponseDocuments : EVA.Core.TransputJobDocument[]; 
  }
  
  export class GetOrderResponse extends EVA.API.GetResponse<EVA.Core.OrderDto> {
    Amounts : EVA.Core.OpenOrderAmounts; 
    HasMoreLines : boolean; 
  }
  
  export class GetOrderStatistics extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrderStatisticsResponse> {
    OrderID : number; // Int32
  }
  
  export class GetOrderStatisticsResponse extends EVA.API.ResponseMessage {
    Statistics : EVA.Core.OrderStatistics; 
  }
  
  export class GetOrderSummaryForShipping extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrderSummaryForShippingResponse> {
    OrderID : number; // Int32
  }
  
  export class GetOrderSummaryForShippingResponse extends EVA.API.ResponseMessage {
    Lines : EVA.Core.Services.GetOrderSummaryForShippingResponseOrderLineSummary[]; 
  }
  
  export class GetOrganizationUnit extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitResponse> {
    OrganizationUnitID : number; // Int32
  }
  
  export class GetOrganizationUnitCreditBalance extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitCreditBalanceResponse> {
    OrganizationUnitID : number; // Int32
  }
  
  export class GetOrganizationUnitCreditBalanceResponse extends EVA.API.ResponseMessage {
    CreditBalance : number; // Decimal
  }
  
  export class GetOrganizationUnitDetailed extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitDetailedResponse> {
    ID : number; // Int32
  }
  
  export class GetOrganizationUnitDetailedResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    ParentID? : number; // Int32, nullable
    Name : string; 
    Description : string; 
    AddressID? : number; // Int32, nullable
    Address : EVA.Core.AddressDto; 
    EmailAddress : string; 
    PhoneNumber : string; 
    Type : EVA.Framework.OrganizationUnitTypes; 
    Status : EVA.Core.OrganizationUnitStatus; 
    OpeningHours : EVA.Core.OpeningHoursDto[]; 
    Subnet : string; 
    RegisterCashLimit? : number; // Decimal, nullable
    SafeCashLimit? : number; // Decimal, nullable
    VisibleByApplicationID : number; // Int32
    Latitude? : number; // Double, nullable
    Longitude? : number; // Double, nullable
    CocNumber : string; 
    VatNumber : string; 
    BankAccount : string; 
    CurrencyID : string; 
    TimeZone : string; 
  }
  
  export class GetOrganizationUnitOpeningHoursForPeriod extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitOpeningHoursForPeriodResponse> {
    OrganizationUnitID : number; // Int32
    From : string; // DateTime
    To : string; // DateTime
  }
  
  export class GetOrganizationUnitOpeningHoursForPeriodResponse extends EVA.API.ResponseMessage {
    OpeningHours : { [ key : string ] : EVA.Core.Services.GetOrganizationUnitOpeningHoursForPeriodResponseOrganizationUnitOpeningHours }; 
  }
  
  export class GetOrganizationUnitResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.OrganizationUnitDto; 
  }
  
  export class GetOrganizationUnitSettings extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitSettingsResponse> {
    OrganizationUnitID : number; // Int32
  }
  
  export class GetOrganizationUnitSettingsResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    ParentID? : number; // Int32, nullable
    BackendID : string; 
    BackendRelationID : string; 
    BackendCompanyID : string; 
    BranchNumber : string; 
    GlobalLocationNumber : string; 
    RegisterCashLimit? : number; // Decimal, nullable
    SafeCashLimit? : number; // Decimal, nullable
    CashHandlerID? : number; // Int32, nullable
    CashHandlerName : string; 
    TypeID : number; // Int32
    Subnet : string; 
    UseForAccounting : boolean; 
    AttachedToUserID? : number; // Int32, nullable
    IpAddress : string; 
    CountryID : string; 
    LanguageID : string; 
    CurrencyID : string; 
    CostPriceCurrencyID : string; 
    TimeZone : string; 
    AssortmentID? : number; // Int32, nullable
    AssortmentName : string; 
    RoleSetID : number; // Int32
    RoleSetName : string; 
  }
  
  export class GetOrganizationUnitsForUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitsForUserResponse> {
    IncludeNonLoginOrganizationUnits : boolean; 
    UserTypeFilter : EVA.Framework.UserTypes; 
  }
  
  export class GetOrganizationUnitsForUserResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.OrganizationUnitDto[]; 
  }
  
  export class GetOrganizationUnitTree extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitTreeResponse> {
    OrganizationUnitID : number; // Int32
  }
  
  export class GetOrganizationUnitTreeResponse extends EVA.API.GetResponse<EVA.Core.Services.OrganizationUnitTreeDto> {
  }
  
  export class GetPaymentTransaction extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetPaymentTransactionResponse> {
    PaymentTransactionID : number; // Int32
  }
  
  export class GetPaymentTransactionResponse extends EVA.API.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto; 
  }
  
  export class GetPickProductDiscountOptionsForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetPickProductDiscountOptionsForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class GetPickProductDiscountOptionsForOrderLine extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetPickProductDiscountOptionsForOrderLineResponse> {
    OrderLineID : number; // Int32
  }
  
  export class GetPickProductDiscountOptionsForOrderLineResponse extends EVA.API.ResponseMessage {
    Options : number[]; 
    CurrentSelection? : number; // Int32, nullable
    CurrentTier : string; 
  }
  
  export class GetPickProductDiscountOptionsForOrderResponse extends EVA.API.ResponseMessage {
    OptionsPerLine : { [ key : number ] : EVA.Core.Services.GetPickProductDiscountOptionsForOrderResponsePickProductDiscountOptions }; 
  }
  
  export class GetPotentialBundleProductsForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetPotentialBundleProductsForOrderResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    IncludedFields : string[]; 
    ProductIDs : number[]; 
  }
  
  export class GetPotentialBundleProductsForOrderResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.GetPotentialBundleProductsForOrderResponseBundleProduct[]; 
  }
  
  export class GetPotentialDiscountsForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetPotentialDiscountsResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    ProductID? : number; // Int32, nullable
  }
  
  export class GetPotentialDiscountsForProductSearch extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetPotentialDiscountsResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    SearchProductsRequest : EVA.Core.Services.SearchProducts; 
  }
  
  export class GetPotentialDiscountsResponse extends EVA.API.ResponseMessage {
    OrderDiscounts : EVA.Core.Services.PotentialDiscountDto[]; 
    ProductDiscounts : { [ key : number ] : EVA.Core.Services.PotentialDiscountDto[] }; 
  }
  
  export class GetProductAvailabilityData extends EVA.API.GetRequestGeneric<EVA.Core.Services.GetProductAvailabilityDataResponse> {
  }
  
  export class GetProductAvailabilityDataResponse extends EVA.API.GetResponse<EVA.Core.ProductAvailabilityDataDto> {
  }
  
  export class GetProductBundle extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductBundleResponse> {
    ID : number; // Int32
    IncludedFields : string[]; 
  }
  
  export class GetProductBundleLineDto {
    ID : number; // Int32
    Description : string; 
    BackendID : string; 
    Type : EVA.Core.ProductBundleLineTypes; 
    DefaultProduct : EVA.Core.Services.ProductBundlesProductInfo; 
    Options : EVA.Core.Services.GetProductBundleLineOptionDto[]; 
  }
  
  export class GetProductBundleLineOptionDto {
    ID : number; // Int32
    Product : EVA.Core.Services.ProductBundlesProductInfo; 
  }
  
  export class GetProductBundleResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    BackendID : string; 
    BundleProduct : EVA.Core.Services.ProductBundlesProductInfo; 
    BundlePricing : EVA.Core.Services.BundleProductPriceInfo; 
    Lines : EVA.Core.Services.GetProductBundleLineDto[]; 
  }
  
  export class GetProductDetail extends EVA.API.GetRequestGeneric<EVA.Core.Services.GetProductDetailResponse> {
  }
  
  export class GetProductDetailResponse extends EVA.API.GetResponse<any> {
  }
  
  export class GetProductPrices extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductPricesResponse> {
    ProductIDs : number[]; 
  }
  
  export class GetProductPricesResponse extends EVA.API.ResponseMessage {
    Prices : EVA.Core.Services.PriceInfo[]; 
  }
  
  export class GetProductPricing extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductPricingResponse> {
    ProductID : number; // Int32
  }
  
  export class GetProductPricingResponse extends EVA.API.ResponseMessage {
    UnitPrice : number; // Decimal
    OriginalUnitPrice? : number; // Decimal, nullable
    TaxRate : number; // Decimal
    UnitPriceInTax : number; // Decimal
    OriginalUnitPriceInTax? : number; // Decimal, nullable
    CurrencyID : string; 
    UnitCost? : number; // Decimal, nullable
    CostPriceCurrencyID : string; 
  }
  
  export class GetProductRequirementByID extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductRequirementByIDResponse> {
    ID : number; // Int32
  }
  
  export class GetProductRequirementByIDResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    ProductID : number; // Int32
    ProductCustomID : string; 
    ProductName : string; 
    Name : string; 
    DataType : EVA.Core.ProductRequirementDataTypes; 
    IsArray : boolean; 
    IsRequired : boolean; 
    Data : any; 
  }
  
  export class GetProductRequirementValuesForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductRequirementValuesForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class GetProductRequirementValuesForOrderLine extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductRequirementValuesForOrderLineResponse> {
    OrderLineID : number; // Int32
  }
  
  export class GetProductRequirementValuesForOrderLineResponse extends EVA.API.ResponseMessage {
    Values : { [ key : number ] : any }; 
  }
  
  export class GetProductRequirementValuesForOrderResponse extends EVA.API.ResponseMessage {
    Values : { [ key : number ] : { [ key : number ] : any } }; 
  }
  
  export class GetProducts extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductsResponse> {
    ProductIDs : number[]; 
    IncludedFields : string[]; 
  }
  
  export class GetProductSearchSuggestions extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductSearchSuggestionsResponse> {
    Text : string; 
    MaxSuggestions? : number; // Int32, nullable
  }
  
  export class GetProductSearchSuggestionsResponse extends EVA.API.ResponseMessage {
    Suggestions : EVA.Core.SuggestionModel[]; 
  }
  
  export class GetProductsResponse extends EVA.API.ResponseMessage {
    Products : { [ key : number ] : any }; 
  }
  
  export class GetProductStructure extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductStructureResponse> {
    Code : string; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class GetProductStructureResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    Code : string; 
    Name : string; 
    LanguageID : string; 
    CountryID : string; 
    Definition : EVA.Core.ProductStructureDefinition; 
  }
  
  export class GetProductSupplierInfoForProducts extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetProductSupplierInfoForProductsResponse> {
    // The products that will be ordered, not the supplier product
    ProductIDs : number[]; 
    // The supplier
    OrganizationUnitID : number; // Int32
  }
  
  export class GetProductSupplierInfoForProductsResponse extends EVA.API.ResponseMessage {
    ProductSupplierInfos : EVA.Core.Services.GetProductSupplierInfoForProductsResponseProductSupplierInfo[]; 
  }
  
  export class GetPurchaseOrderShipment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetPurchaseOrderShipmentResponse> {
    ShipmentID : number; // Int32
  }
  
  export class GetPurchaseOrderShipmentResponse extends EVA.API.ResponseMessage {
    Shipment : EVA.Core.PurchaseOrderShipmentDto; 
  }
  
  export class GetQuantityOnHandForProducts extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetQuantityOnHandForProductsResponse> {
    OrganizationUnitID : number; // Int32
    ProductIDs : number[]; 
  }
  
  export class GetQuantityOnHandForProductsResponse extends EVA.API.GetResponse<{ [ key : number ] : number }> {
  }
  
  export class GetRequiredDataForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetRequiredDataForOrderResponse> {
    OrderID : number; // Int32
    RequiredFor : EVA.Core.RequiredFor; 
  }
  
  export class GetRequiredDataForOrderResponse extends EVA.API.ResponseMessage {
    RequiredData : EVA.Core.RequiredData; 
  }
  
  export class GetReturnableStatusForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetReturnableStatusForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class GetReturnableStatusForOrderResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ReturnableStatusForOrderLine[]; 
    ReturnSets : EVA.Core.Services.OrderLinesReturnSet[]; 
  }
  
  export class GetReturnToSupplierData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetReturnToSupplierDataResponse> {
    OrderID : number; // Int32
  }
  
  export class GetReturnToSupplierDataResponse extends EVA.API.ResponseMessage {
    Reason : EVA.Framework.EnumDto; 
  }
  
  export class GetRobotsTxt extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetRobotsTxtResponse> {
  }
  
  export class GetRobotsTxtResponse extends EVA.API.ResponseMessage {
    Robots : string; 
  }
  
  export class GetSalesTaxEstimateForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SalesTaxEstimateForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class GetSerialNumber extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetSerialNumberResponse> {
    OrderLineID : number; // Int32
  }
  
  export class GetSerialNumberResponse extends EVA.API.ResponseMessage {
    SerialNumber : string; 
  }
  
  export class GetShipmentDetails extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetShipmentDetailsResponse> {
    BackendID : string; 
    OrganizationUnitID? : number; // Int32, nullable
  }
  
  export class GetShipmentDetailsOrder {
    OrderID : number; // Int32
    BackendID : string; 
    CustomerReference : string; 
  }
  
  export class GetShipmentDetailsResponse extends EVA.API.ResponseMessage {
    ReceiveMethod : EVA.Core.ShipmentReceiveMethods; 
    IsCompleted : boolean; 
    WorkSet : EVA.Core.Services.ReceiveShipmentWorkSet; 
  }
  
  export class GetShipmentLines extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetShipmentLinesResponse> {
    ShipmentID : number; // Int32
  }
  
  export class GetShipmentLinesResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.GetShipmentLinesResponseModel[]; 
  }
  
  export class GetShipmentSettings extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetShipmentSettingsResponse> {
    OrganizationUnitID? : number; // Int32, nullable
  }
  
  export class GetShipmentSettingsResponse extends EVA.API.ResponseMessage {
    OrganizationUnitID : number; // Int32
    DefaultReceiveMethod : EVA.Core.ShipmentReceiveMethods; 
  }
  
  export class GetShippingMethodsForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetShippingMethodsForOrderResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
  }
  
  export class GetShippingMethodsForOrderResponse extends EVA.API.ResponseMessage {
    ShippingMethods : EVA.Core.ShippingMethodByOrderLineDto[]; 
  }
  
  export class GetShoppingCart extends EVA.API.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    SessionID : string; 
    CartID? : number; // Int32, nullable
    ProductProperties : string[]; 
  }
  
  export class GetShoppingCartInfo extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetShoppingCartInfoResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
  }
  
  export class GetShoppingCartInfoResponse extends EVA.API.ResponseMessage {
    OrderID : number; // Int32
    QuantityOrdered : number; // Int32
    TotalAmount : number; // Decimal
    // Obsolete
    ForeignTotalAmount : number; // Decimal
    CurrencyID : string; 
  }
  
  export class GetShopsByProximity extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetShopsByProximityResponse> {
    // Amount of stores to return, defaults to 10, max 100
    Limit? : number; // Int32, nullable
    // Range around the coordinates to look for shops, defaults to 50.000m, max 250.000m
    Range? : number; // Int32, nullable
    // Filter only stores with available stock
    HasStock : boolean; 
    ProductID? : number; // Int32, nullable
    Latitude : number; // Double
    Longitude : number; // Double
  }
  
  export class GetShopsByProximityResponse extends EVA.API.ResponseMessage {
    Shops : EVA.Core.Services.ShopInfo[]; 
  }
  
  export class GetStation extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStationResponse> {
    ID : number; // Int32
  }
  
  export class GetStationProxyStatus extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStationProxyStatusResponse> {
    ProxyID : string; 
  }
  
  export class GetStationProxyStatusResponse extends EVA.API.ResponseMessage {
    Registered : boolean; 
    OrganizationUnitID : number; // Int32
    StationID : number; // Int32
  }
  
  export class GetStationResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.StationDto; 
  }
  
  export class GetStockAvailabilityEstimateForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStockAvailabilityEstimateForOrderResponse> {
    OrderID : number; // Int32
    OrderLineIDs : number[]; 
  }
  
  export class GetStockAvailabilityEstimateForOrderResponse extends EVA.API.ResponseMessage {
    OrderLines : EVA.Core.Services.GetStockAvailabilityEstimateForOrderResponseOrderLine[]; 
  }
  
  export class GetStockAvailabilityTimeline extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStockAvailabilityTimelineResponse> {
    OrganizationUnitID? : number; // Int32, nullable
    ProductIDs : number[]; 
    FromDate? : string; // DateTime, nullable
    ToDate? : string; // DateTime, nullable
    Type : EVA.Core.Services.AvailabilityTimelineItemTypes; 
  }
  
  export class GetStockAvailabilityTimelineResponse extends EVA.API.ResponseMessage {
    TimelineItems : EVA.Core.Services.GetStockAvailabilityTimelineResponseTimelineItem[]; 
  }
  
  export class GetStockByStockLabelForProducts extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStockByStockLabelForProductsResponse> {
    OrganizationUnitID : number; // Int32
    ProductIDs : number[]; 
    StockLabelIDs : number[]; 
  }
  
  export class GetStockByStockLabelForProductsResponse extends EVA.API.ResponseMessage {
    Stock : { [ key : number ] : EVA.Core.Services.GetStockByStockLabelForProductsResponseStockLabelStock[] }; 
  }
  
  export class GetStockDetailsForProduct extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStockDetailsForProductResponse> {
    ProductID : number; // Int32
  }
  
  export class GetStockDetailsForProductResponse extends EVA.API.ResponseMessage {
    PromisedDeliveryDate? : string; // DateTime, nullable
    PromisedDeliveryStatus? : EVA.Core.ProductPromisedDeliveryStatuses; 
    QuantityOnHand : number; // Int32
    SellableQuantityAvailable : number; // Int32
    StockPerLabel : { [ key : number ] : number }; 
    StockInTransit : EVA.Core.StockDetailsInTransit[]; 
    SellableStockInStoresWithinApplication : number; // Int32
    SellableStockInWarehouses : EVA.Core.StockDetailsOrganizationUnitWithStock[]; 
  }
  
  export class GetStockLabels extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStockLabelsResponse> {
  }
  
  export class GetStockLabelsResponse extends EVA.API.ResponseMessage {
    StockLabels : EVA.Core.Services.GetStockLabelsResponseStockLabelDto[]; 
  }
  
  export class GetStockNotification extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StockNotificationResponse> {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    EmailAddress : string; 
  }
  
  export class GetStockNotificationForCurrentUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StockNotificationResponse> {
    ProductID : number; // Int32
    OrganizationUnitID? : number; // Int32, nullable
  }
  
  export class GetStockResource extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStockResourceResponse> {
    ResourceID : number; // Int32
  }
  
  export class GetStockResourceResponse extends EVA.API.ResponseMessage {
    Resource : EVA.Core.Services.StockResourceDto; 
  }
  
  export class GetStringTranslation extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetStringTranslationResponse> {
    Key : string; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class GetStringTranslationResponse extends EVA.API.ResponseMessage {
    Key : string; 
    LanguageID : string; 
    CountryID : string; 
    Value : string; 
  }
  
  export class GetSuppliersForOrganizationUnit extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetSuppliersForOrganizationUnitResponse> {
    OrganizationUnitID : number; // Int32
  }
  
  export class GetSuppliersForOrganizationUnitResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.GetSuppliersForOrganizationUnitResponseModel[]; 
  }
  
  export class GetSupplierStockForProduct extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetSupplierStockForProductResponse> {
    OrganizationUnitID : number; // Int32
    SupplierID : number; // Int32
    ProductID : number; // Int32
  }
  
  export class GetSupplierStockForProductResponse extends EVA.API.ResponseMessage {
    AvailableStock : number; // Int32
  }
  
  export class GetTaxRate extends EVA.API.GetRequest implements EVA.API.IRequestRespondsAs<EVA.Core.Services.GetTaxRateResponse> {
  }
  
  export class GetTaxRateResponse extends EVA.API.GetResponse<EVA.Core.TaxRateModel> {
  }
  
  export class GetTokenInfo extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetTokenInfoResponse> {
    Authorization : string; 
  }
  
  export class GetTokenInfoResponse extends EVA.API.ResponseMessage {
    UserID : number; // Int32
    ExpirationDate? : string; // DateTime, nullable
    OrganizationUnitID? : number; // Int32, nullable
    ApplicationID? : number; // Int32, nullable
    LanguageID : string; 
    TemporaryAccessType : string; 
  }
  
  export class GetTransportOrderLineData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetTransportOrderLineDataResponse> {
    OrderLineID : number; // Int32
  }
  
  export class GetTransportOrderLineDataResponse extends EVA.API.ResponseMessage {
    TransportOrderLineData : EVA.Core.TransportOrderLineData; 
  }
  
  export class GetUser extends EVA.API.GetRequestGeneric<EVA.Core.Services.GetUserResponse> {
  }
  
  export class GetUserBySocialSecurityNumber extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetUserBySocialSecurityNumberResponse> {
    SocialSecurityNumber : string; 
  }
  
  export class GetUserBySocialSecurityNumberResponse extends EVA.API.ResponseMessage {
    UserID? : number; // Int32, nullable
  }
  
  export class GetUserConsignment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetUserConsignmentResponse> {
    UserID : number; // Int32
  }
  
  export class GetUserConsignmentResponse extends EVA.API.ResponseMessage {
    UseConsignment : boolean; 
  }
  
  export class GetUserDebtorData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetUserDebtorDataResponse> {
    UserID : number; // Int32
  }
  
  export class GetUserDebtorDataResponse extends EVA.API.ResponseMessage {
    PaymentTerms : string; 
    CreditLimit? : number; // Decimal, nullable
    ColloPrice? : number; // Decimal, nullable
    PalletPrice? : number; // Decimal, nullable
    OversizedPrice? : number; // Decimal, nullable
    AssignedToUser : EVA.Core.Services.AssignedToUser; 
    IsTaxExempt : boolean; 
  }
  
  export class GetUserGroupByID extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetUserGroupByIDResponse> {
    ID : number; // Int32
  }
  
  export class GetUserGroupByIDResponse extends EVA.API.ResponseMessage {
    Name : string; 
  }
  
  export class GetUserIdentificationByID extends EVA.API.GetRequestGeneric<EVA.Core.Services.GetUserIdentificationByIDResponse> {
  }
  
  export class GetUserIdentificationByIDResponse extends EVA.API.GetResponse<EVA.Core.Services.IdentificationDto> {
  }
  
  export class GetUserInfoBySocialSecurityNumber extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetUserInfoBySocialSecurityNumberResponse> {
    CountryID : string; 
    SocialSecurityNumber : string; 
  }
  
  export class GetUserInfoBySocialSecurityNumberResponse extends EVA.API.ResponseMessage {
    Data : EVA.Core.UserDto; 
  }
  
  export class GetUserPhoneNumbers extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetUserPhoneNumbersResponse> {
    UserID? : number; // Int32, nullable
  }
  
  export class GetUserPhoneNumbersResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.UserPhoneNumberModel[]; 
  }
  
  export class GetUserResponse extends EVA.API.GetResponse<EVA.Core.UserDto> {
  }
  
  export class GetWarehouseOrderData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetWarehouseOrderDataResponse> {
    OrderID : number; // Int32
  }
  
  export class GetWarehouseOrderDataResponse extends EVA.API.ResponseMessage {
    WarehouseOrderData : EVA.Core.WarehouseOrderData; 
  }
  
  export class GetWebshops extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetWebshopsResponse> {
  }
  
  export class GetWebshopsResponse extends EVA.API.ResponseMessage {
    Webshops : EVA.Core.Services.GetWebshopsResponseWebshopDto[]; 
  }
  
  export class GetWishList extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetWishListResponse> {
    OrderID : number; // Int32
    AccessToken : string; 
    IncludedProperties : string[]; 
    ShowUnconfirmedFundings : boolean; 
  }
  
  export class GetWishListOrderLineData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetWishListOrderLineDataResponse> {
    OrderID : number; // Int32
  }
  
  export class GetWishListOrderLineDataResponse extends EVA.API.ResponseMessage {
    Lines : EVA.Core.Services.GetWishListOrderLineDataResponseWishListOrderLineDataDto[]; 
  }
  
  export class GetWishListResponse extends EVA.API.GetResponse<EVA.Core.Services.WishListDto> {
  }
  
  export class GetWishListsForUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetWishListsForUserResponse> {
    ID? : number; // Int32, nullable
    ShowClosedOrders : boolean; 
    ShowUnconfirmedFundings : boolean; 
    HasOrderLines : boolean; 
    IncludedProperties : string[]; 
  }
  
  export class GetWishListsForUserResponse extends EVA.API.GetResponse<EVA.Core.Services.WishListDto[]> {
  }
  
  export class GiftWrap {
    Message : string; 
    Lines : EVA.Core.Services.WrapLine[]; 
  }
  
  export class HasSubscription extends EVA.API.RequestMessageGeneric<EVA.Core.Services.HasSubscriptionResponse> {
    EmailAddress : string; 
    UserID? : number; // Int32, nullable
    Type : EVA.Core.SubscriptionTypes; 
  }
  
  export class HasSubscriptionResponse extends EVA.API.ResponseMessage {
    IsSubscribed : boolean; 
  }
  
  export class IdentificationDto {
    ID : number; // Int32
    Type : EVA.Core.IdentificationTypes; 
    Number : string; 
    ValidTo : string; // DateTime
    IssuingDate? : string; // DateTime, nullable
    IssuingCity : string; 
    IssuingCountryID : string; 
    OriginatingCountryID : string; 
    DocumentID : string; 
  }
  
  export class InterbranchOrganizationUnit {
    ID : number; // Int32
    Name : string; 
  }
  
  export class CreateInvoicesForOrderResponseInvoice {
    ID : number; // Int32
    InvoiceNumber : string; 
    TypeID : number; // Int32
    StatusID : number; // Int32
  }
  
  export class ListInvoicesForOrderResponseInvoice {
    ID : number; // Int32
    InvoiceNumber : string; 
    InvoiceDate? : string; // DateTime, nullable
    CreatedByID : number; // Int32
    CreationTime : string; // DateTime
  }
  
  export class InvoiceAdditionalAmountDto {
    Type : number; // Int32
    Amount : number; // Decimal
    TaxRate : number; // Decimal
    TaxCodeID : number; // Int32
  }
  
  export class InvoiceBlobDto {
    BlobID : string; 
  }
  
  export class InvoiceDetailLineDto {
    ID : number; // Int32
    QuantityInvoiced : number; // Int32
    OrderLine : EVA.Core.Services.InvoiceDetailsOrderLineDto; 
    ShipmentLineID? : number; // Int32, nullable
    InvoiceDate? : string; // DateTime, nullable
    UnitCost? : number; // Decimal, nullable
    Amount : number; // Decimal
    QuantityToInvoice : number; // Int32
    TaxRate : number; // Decimal
    AmountInTax : number; // Decimal
  }
  
  export class InvoiceDetailsDto {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    PaymentTermStartDate? : string; // DateTime, nullable
    PaymentTermDueDate? : string; // DateTime, nullable
    InvoiceDate? : string; // DateTime, nullable
    InvoiceNumber : string; 
    Description : string; 
    AdditionalAmounts : EVA.Core.Services.InvoiceAdditionalAmountDto[]; 
    Lines : EVA.Core.Services.InvoiceDetailLineDto[]; 
    Blobs : EVA.Core.Services.InvoiceBlobDto[]; 
    Status : EVA.Core.InvoiceStatuses; 
    SupplierOrganizationUnitID? : number; // Int32, nullable
    TotalAmount? : number; // Decimal, nullable
    HoldStatusID? : number; // Int32, nullable
    OriginalTotalAmount? : number; // Decimal, nullable
    CurrencyID : string; 
  }
  
  export class InvoiceDetailsOrderLineDto {
    Description : string; 
    UnitCost : number; // Decimal
    UnitPrice : number; // Decimal
    ID : number; // Int32
    OrderID : number; // Int32
    ProductID? : number; // Int32, nullable
  }
  
  export class ShipOrderLinesLine {
    ID : number; // Int32
    Quantity : number; // Int32
    BackendReference : string; 
  }
  
  export class ListAddressBook extends EVA.API.PagedResultRequest<EVA.Core.Services.ListAddressBookResponse> {
    UserID? : number; // Int32, nullable
  }
  
  export class ListAddressBookResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.AddressBookDto> {
  }
  
  export class ListApplications extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListApplicationsResponse> {
  }
  
  export class ListApplicationsForCatalog extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListApplicationsForCatalogResponse> {
  }
  
  export class ListApplicationsForCatalogResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ApplicationDto[]; 
  }
  
  export class ListApplicationsResponse extends EVA.API.GetResponse<EVA.Core.Services.ApplicationDto[]> {
  }
  
  export class ListAvailableInsurancesForOrderLine extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListAvailableInsurancesForOrderLineResponse> {
    OrderLineID : number; // Int32
  }
  
  export class ListAvailableInsurancesForOrderLineResponse extends EVA.API.ResponseMessage {
    Insurances : EVA.Core.InsuranceItemDto[]; 
  }
  
  export class ListAvailableRecurringTasks extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListAvailableRecurringTasksResponse> {
  }
  
  export class ListAvailableRecurringTasksResponse extends EVA.API.ResponseMessage {
    Tasks : EVA.Core.Services.ListAvailableRecurringTasksResponseTaskPluginDto[]; 
  }
  
  export class ListAvailableShippingMethods extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListAvailableShippingMethodsResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    OrderLineIDs : number[]; 
  }
  
  export class ListAvailableShippingMethodsResponse extends EVA.API.ResponseMessage {
    AvailableShippingMethods : EVA.Core.ShippingMethodByOrderLineDto[]; 
  }
  
  export class ListAvailableTimeZones extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListAvailableTimeZonesResponse> {
  }
  
  export class ListAvailableTimeZonesResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListAvailableTimeZonesResponseModel[]; 
  }
  
  export class ListBlobsForFinancialPeriod extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListBlobsForFinancialPeriodResponse> {
    FinancialPeriodID : number; // Int32
  }
  
  export class ListBlobsForFinancialPeriodResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.FinancialPeriodBlobDto[]; 
  }
  
  export class ListBlobsForInvoice extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListBlobsForInvoiceResponse> {
    InvoiceID : number; // Int32
  }
  
  export class ListBlobsForInvoiceResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListBlobsForInvoiceResponseModel[]; 
  }
  
  export class ListBlobsForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListBlobsForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class ListBlobsForOrderResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.OrderBlobDto[]; 
  }
  
  export class ListBookings extends EVA.API.PagedResultRequest<EVA.Core.Services.ListBookingsResponse> {
  }
  
  export class ListBookingsResponse extends EVA.API.PagedResultResponse<EVA.Core.GeneralLedgerDto> {
  }
  
  export class ListBrandsPaged extends EVA.API.PagedResultRequest<EVA.Core.Services.ListBrandsPagedResponse> {
  }
  
  export class ListBrandsPagedResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListBrandsPagedResponseBrandDto> {
  }
  
  export class ListCashDeposits extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListCashDepositsResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListCashDepositsFilter>; 
  }
  
  export class ListCashDepositsResponse extends EVA.API.PagedResultResponse<EVA.Core.ListCashDepositsItem> {
  }
  
  export class ListCashExpenses extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListCashExpensesResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListCashExpensesFilter>; 
  }
  
  export class ListCashExpensesResponse extends EVA.API.PagedResultResponse<EVA.Core.ListCashExpensesItem> {
  }
  
  export class ListCashTransactionLedger extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListCashTransactionLedgerResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListCashTransactionLedgerFilter>; 
  }
  
  export class ListCashTransactionLedgerResponse extends EVA.API.PagedResultResponse<EVA.Core.ListCashTransactionLedgerItem> {
  }
  
  export class ListCommittedOrderLines extends EVA.API.PagedResultRequest<EVA.Core.Services.ListCommittedOrderLinesResponse> {
    ProductID : number; // Int32
  }
  
  export class ListCommittedOrderLinesResponse extends EVA.API.PagedResultResponse<EVA.Core.CommittedOrderLine> {
  }
  
  export class ListCountries extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListCountriesResponse> {
    FetchAll : boolean; 
  }
  
  export class ListCountriesResponse extends EVA.API.GetResponse<EVA.Core.Services.CountryDto[]> {
  }
  
  export class ListCurrencies extends EVA.API.PagedResultRequest<EVA.Core.Services.ListCurrenciesResponse> {
  }
  
  export class ListCurrenciesResponse extends EVA.API.PagedResultResponse<EVA.Core.CurrencyWithExchangeRate> {
  }
  
  export class ListDevices extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListDevicesResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListDevicesFilter>; 
  }
  
  export class ListDevicesResponse extends EVA.API.PagedResultResponse<EVA.Core.ListDevicesModel> {
  }
  
  export class ListDeviceTypes extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListDeviceTypesResponse> {
  }
  
  export class ListDeviceTypesResponse extends EVA.API.ResponseMessage {
    DeviceTypes : EVA.Framework.FlagsEnumDto[]; 
  }
  
  export class ListEntityTranslations extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListEntityTranslationsResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListEntityTranslationsFilter>; 
  }
  
  export class ListEntityTranslationsResponse extends EVA.API.PagedResultResponse<EVA.Core.ListEntityTranslation> {
  }
  
  export class ListEnumValues extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListEnumValuesResponse> {
    Name : string; 
  }
  
  export class ListEnumValuesResponse extends EVA.API.ResponseMessage {
    Values : EVA.Core.Services.ListEnumValuesResponseEnumValue[]; 
    IsFlags : boolean; 
  }
  
  export class ListEventLedger extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListEventLedgerResponse> {
    Query : string; 
    PageConfig : EVA.Framework.ScrollablePageConfig<EVA.Core.EventLedgerFilters>; 
  }
  
  export class ListEventLedgerResponse extends EVA.API.ResponseMessage {
    Result : EVA.Framework.ScrollablePagedResult<EVA.Core.EventLedgerDocument>; 
  }
  
  export class ListExternalOrderStatusForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListExternalOrderStatusForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class ListExternalOrderStatusForOrderResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListExternalOrderStatusForOrderResponseExternalOrderStatus[]; 
  }
  
  export class ListFeedSubscriptions extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListFeedSubscriptionsResponse> {
  }
  
  export class ListFeedSubscriptionsResponse extends EVA.API.GetResponse<EVA.Core.Services.FeedSubscriptionDto[]> {
  }
  
  export class ListFinancialEvents extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListFinancialEventsResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListFinancialEventsFilter>; 
  }
  
  export class ListFinancialEventsResponse extends EVA.API.PagedResultResponse<EVA.Core.ListFinancialEventRow> {
  }
  
  export class ListFinancialPeriodAudits extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListFinancialPeriodAuditsResponse> {
    PageConfig : EVA.Framework.PageConfig; 
  }
  
  export class ListFinancialPeriodAuditsResponse extends EVA.API.PagedResultResponse<EVA.Core.FinancialPeriodAuditDto> {
  }
  
  export class ListFinancialPeriodExports extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListFinancialPeriodExportsResponse> {
    FinancialPeriodID : number; // Int32
  }
  
  export class ListFinancialPeriodExportsResponse extends EVA.API.ResponseMessage {
    Results : EVA.Core.Services.ListFinancialPeriodExportsResponseModel[]; 
  }
  
  export class ListFinancialPeriods extends EVA.API.PagedResultRequest<EVA.Core.Services.ListFinancialPeriodsResponse> {
  }
  
  export class ListFinancialPeriodsResponse extends EVA.API.PagedResultResponse<EVA.Core.FinancialPeriodDto> {
  }
  
  export class ListGeneralLedgers extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListGeneralLedgersResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListGeneralLedgersFilter>; 
  }
  
  export class ListGeneralLedgersResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListGeneralLedgersResponseGeneralLedger> {
  }
  
  export class ListInsurancesForProduct extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListInsurancesForProductResponse> {
    ProductID : number; // Int32
  }
  
  export class ListInsurancesForProductResponse extends EVA.API.ResponseMessage {
    Insurances : EVA.Core.InsuranceItemDto[]; 
  }
  
  export class ListInterbranchOrganizationUnitForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListInterbranchOrganizationUnitForOrderResponse> {
    OrderID? : number; // Int32, nullable
    SessionID : string; 
    ExcludeClosed : boolean; 
  }
  
  export class ListInterbranchOrganizationUnitForOrderResponse extends EVA.API.ResponseMessage {
    OrganizationUnits : EVA.Core.Services.InterbranchOrganizationUnit[]; 
  }
  
  export class ListInvoices extends EVA.API.PagedResultRequest<EVA.Core.Services.ListInvoicesResponse> {
    InvoiceNumber : string; 
    Type : EVA.Core.InvoiceTypes; 
    StartDate? : string; // DateTime, nullable
    EndDate? : string; // DateTime, nullable
  }
  
  export class ListInvoicesForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListInvoicesForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class ListInvoicesForOrderResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListInvoicesForOrderResponseInvoice[]; 
  }
  
  export class ListInvoicesResponse extends EVA.API.PagedResultResponse<EVA.Core.ListInvoicesDto> {
  }
  
  export class ListManualDiscounts extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListManualDiscountsResponse> {
    // Defaults to Sales
    OrderType : EVA.Core.OrderTypes; 
  }
  
  export class ListManualDiscountsResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListManualDiscountsResponseManualDiscountDto[]; 
  }
  
  export class ListMessageQueueErrors extends EVA.API.PagedResultRequest<EVA.Core.Services.ListMessageQueueErrorsResponse> {
  }
  
  export class ListMessageQueueErrorsResponse extends EVA.API.PagedResultResponse<EVA.Core.MessageQueueErrorDto> {
  }
  
  export class ListOrderExportsForOrder extends EVA.API.PagedResultRequest<EVA.Core.Services.ListOrderExportsForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class ListOrderExportsForOrderResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListOrderExportsForOrderResponseOrderExportDto> {
  }
  
  export class ListOrderLedgerForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListOrderLedgerForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class ListOrderLedgerForOrderResponse extends EVA.API.ResponseMessage {
    Ledgers : EVA.Core.Services.OrderLedgerDto[]; 
  }
  
  export class ListOrderLines extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListOrderLinesResponse> {
    OrderID : number; // Int32
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListOrderLinesFilter>; 
  }
  
  export class ListOrderLinesInvoiceSummary extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListOrderLinesInvoiceSummaryResponse> {
    OrderID : number; // Int32
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListOrderLinesFilter>; 
  }
  
  export class ListOrderLinesInvoiceSummaryResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListOrderLinesInvoiceSummaryResponseModel> {
  }
  
  export class ListOrderLinesResponse extends EVA.API.PagedResultResponse<EVA.Core.OrderLineDto> {
  }
  
  export class ListOrdersForCustomer extends EVA.API.PagedResultRequest<EVA.Core.Services.ListOrdersForCustomerResponse> {
    ID : number; // Int32
    OpenOrdersOnly : boolean; 
  }
  
  export class ListOrdersForCustomerResponse extends EVA.API.PagedResultResponse<EVA.Core.OrderDto> {
  }
  
  export class ListOrderShipments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListOrderShipmentsResponse> {
    OrderID : number; // Int32
  }
  
  export class ListOrderShipmentsResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListOrderShipmentsResponseModel[]; 
  }
  
  export class ListOrdersWithCustomerReferences extends EVA.API.PagedResultRequest<EVA.Core.Services.ListOrdersWithCustomerReferencesResponse> {
  }
  
  export class ListOrdersWithCustomerReferencesResponse extends EVA.API.PagedResultResponse<EVA.Core.OrderWithCustomerReferences> {
  }
  
  export class ListOrganizationUnitByProximity extends EVA.API.PagedResultRequest<EVA.Core.Services.ListOrganizationUnitByProximityResponse> {
    Latitude : number; // Double
    Longitude : number; // Double
  }
  
  export class ListOrganizationUnitByProximityResponse extends EVA.API.PagedResultResponse<EVA.Core.OrganizationUnitDto> {
  }
  
  export class ListOrganizationUnits extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListOrganizationUnitsResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListOrganizationUnitsFilter>; 
  }
  
  export class ListOrganizationUnitsForEnrollment extends EVA.API.PagedResultRequest<EVA.Core.Services.ListOrganizationUnitsForEnrollmentResponse> {
  }
  
  export class ListOrganizationUnitsForEnrollmentResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.OrganizationUnitEnrollmentDto[]; 
  }
  
  export class ListOrganizationUnitsResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListOrganizationUnitsResponseOrganizationUnit> {
  }
  
  export class ListOrganizationUnitSuppliers extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListOrganizationUnitSuppliersResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListOrganizationUnitSuppliersFilter>; 
  }
  
  export class ListOrganizationUnitSuppliersResponse extends EVA.API.PagedResultResponse<EVA.Core.ListOrganizationUnitSuppliersModel> {
  }
  
  export class ListProductAvailabilityData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListProductAvailabilityDataResponse> {
  }
  
  export class ListProductAvailabilityDataResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.ProductAvailabilityDataDto[]; 
  }
  
  export class ListProductBundles extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListProductBundlesResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListProductBundlesFilter>; 
    IncludedFields : string[]; 
  }
  
  export class ListProductBundlesResponse extends EVA.API.ResponseMessage {
    Result : EVA.Framework.PagedResultGeneric<EVA.Core.Services.ListProductBundlesResponseResult>; 
  }
  
  export class ListProductBundlesResponseResult {
    ID : number; // Int32
    BackendID : string; 
    BundleProduct : EVA.Core.Services.ProductBundlesProductInfo; 
    BundlePricing : EVA.Core.Services.BundleProductPriceInfo; 
  }
  
  export class ListProductRequirements extends EVA.API.PagedResultRequest<EVA.Core.Services.ListProductRequirementsResponse> {
  }
  
  export class ListProductRequirementsResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ProductRequirementDto> {
  }
  
  export class ListProductStructures extends EVA.API.PagedResultRequest<EVA.Core.Services.ListProductStructuresResponse> {
  }
  
  export class ListProductStructuresResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.GetProductStructureResponse> {
  }
  
  export class ListPurchaseOrderShipmentLines extends EVA.API.PagedResultRequest<EVA.Core.Services.ListPurchaseOrderShipmentLinesResponse> {
    ShipmentID : number; // Int32
  }
  
  export class ListPurchaseOrderShipmentLinesResponse extends EVA.API.PagedResultResponse<EVA.Core.PurchaseOrderShipmentLineDto> {
  }
  
  export class ListPurchaseOrderShipments extends EVA.API.PagedResultRequest<EVA.Core.Services.ListPurchaseOrderShipmentsResponse> {
    OrganizationUnitID? : number; // Int32, nullable
    BackendID : string; 
    TrackingCode : string; 
    IsCompleted? : boolean; 
  }
  
  export class ListPurchaseOrderShipmentsResponse extends EVA.API.PagedResultResponse<EVA.Core.PurchaseOrderShipmentDto> {
  }
  
  export class ListRecurringTasks extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListRecurringTasksResponse> {
  }
  
  export class ListRecurringTasks2 extends EVA.API.PagedResultRequest<EVA.Core.Services.ListRecurringTasks2Response> {
  }
  
  export class ListRecurringTasks2Response extends EVA.API.PagedResultResponse<EVA.Framework.RecurringTask> {
  }
  
  export class ListRecurringTasksResponse extends EVA.API.ResponseMessage {
    Tasks : EVA.Framework.RecurringTask[]; 
  }
  
  export class ListRelatedOrders extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListRelatedOrdersResponse> {
    OrderID : number; // Int32
  }
  
  export class ListRelatedOrdersResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListRelatedOrdersResponseModel[]; 
  }
  
  export class ListRequiredStockResourceTypes extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListRequiredStockResourceTypesResponse> {
    ProductID : number; // Int32
  }
  
  export class ListRequiredStockResourceTypesResponse extends EVA.API.ResponseMessage {
    RequiredStockResourceTypes : EVA.Core.Services.StockResourceTypeDto[]; 
  }
  
  export class ListReturnableSuppliersForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListReturnableSuppliersForOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class ListReturnableSuppliersForOrderResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ListReturnableSuppliersForOrderResponseModel[]; 
  }
  
  export class ListShipmentLinesToInvoice extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListShipmentLinesToInvoiceResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListShipmentLinesToInvoiceFilter>; 
  }
  
  export class ListShipmentLinesToInvoiceResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListShipmentLinesToInvoiceResponseModel> {
  }
  
  export class ListShipmentsToInvoice extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListShipmentsToInvoiceResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListShipmentsToInvoiceFilter>; 
  }
  
  export class ListShipmentsToInvoiceResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListShipmentsToInvoiceResponseModel> {
  }
  
  export class ListShopsInArea extends EVA.API.PagedResultRequest<EVA.Core.Services.ListShopsInAreaResponse> {
    NorthWest : EVA.Core.Services.ListShopsInAreaCoordinate; 
    SouthEast : EVA.Core.Services.ListShopsInAreaCoordinate; 
  }
  
  export class ListShopsInAreaResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ShopInfo> {
  }
  
  export class ListStationsForOrganizationUnit extends EVA.API.PagedResultRequest<EVA.Core.Services.ListStationsForOrganizationUnitResponse> {
    OrganizationUnitID : number; // Int32
    DeviceTypeID? : number; // Int32, nullable
  }
  
  export class ListStationsForOrganizationUnitResponse extends EVA.API.PagedResultResponse<EVA.Core.StationDto> {
  }
  
  export class ListStockAllocationRules extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListStockAllocationRulesResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListStockAllocationRulesFilter>; 
  }
  
  export class ListStockAllocationRulesResponse extends EVA.API.PagedResultResponse<EVA.Core.ListStockAllocationRulesItem> {
  }
  
  export class ListStockMutations extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListStockMutationsResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListStockMutationsFilter>; 
  }
  
  export class ListStockMutationsResponse extends EVA.API.ResponseMessage {
    Result : EVA.Framework.PagedResultGeneric<EVA.Core.StockMutationDto>; 
  }
  
  export class ListStockResourcesByProduct extends EVA.API.PagedResultRequest<EVA.Core.Services.ListStockResourcesByProductResponse> {
    ProductID : number; // Int32
    OrganizationUnitIDs : number[]; 
  }
  
  export class ListStockResourcesByProductResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ProductWithResourceDto> {
  }
  
  export class ListStockResourceStockMutations extends EVA.API.PagedResultRequest<EVA.Core.Services.ListStockResourceStockMutationsResponse> {
  }
  
  export class ListStockResourceStockMutationsResponse extends EVA.API.PagedResultResponse<EVA.Core.StockMutationDto> {
  }
  
  export class ListStockResourceTypes extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListStockResourceTypesResponse> {
  }
  
  export class ListStockResourceTypesResponse extends EVA.API.ResponseMessage {
    StockResourceTypes : EVA.Core.Services.StockResourceTypeDto[]; 
  }
  
  export class ListStringTranslations extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListStringTranslationsResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListStringTranslationsFilter>; 
  }
  
  export class ListStringTranslationsResponse extends EVA.API.PagedResultResponse<EVA.Core.ListStringTranslation> {
  }
  
  export class ListSuspendedOrders extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListSuspendedOrdersResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListSuspendedOrdersFilter>; 
  }
  
  export class ListSuspendedOrdersResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ListSuspendedOrdersResponseSuspendedOrderDto> {
  }
  
  export class ListTaxCodes extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListTaxCodesResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.Services.ListTaxCodesFilter>; 
  }
  
  export class ListTaxCodesFilter {
    Name : string; 
  }
  
  export class ListTaxCodesResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.TaxCodeItem> {
  }
  
  export class ListTaxRates extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListTaxRatesResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Core.ListTaxRateModelFilters>; 
  }
  
  export class ListTaxRatesResponse extends EVA.API.PagedResultResponse<EVA.Core.TaxRateModel> {
  }
  
  export class ListUserGroups extends EVA.API.PagedResultRequest<EVA.Core.Services.ListUserGroupsResponse> {
  }
  
  export class ListUserGroupsForUser extends EVA.API.PagedResultRequest<EVA.Core.Services.ListUserGroupsForUserResponse> {
    UserID : number; // Int32
  }
  
  export class ListUserGroupsForUserResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.UserGroupDto> {
  }
  
  export class ListUserGroupsResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.UserGroupDto> {
  }
  
  export class ListUserIdentifications extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListUserIdentificationsResponse> {
    UserID : number; // Int32
  }
  
  export class ListUserIdentificationsResponse extends EVA.API.ResponseMessage {
    Identifications : EVA.Core.Services.IdentificationDto[]; 
  }
  
  export class ListUsersForUserGroup extends EVA.API.PagedResultRequest<EVA.Core.Services.ListUsersForUserGroupResponse> {
    UserGroupID : number; // Int32
  }
  
  export class ListUsersForUserGroupResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.SimpleUserDto> {
  }
  
  export class ListUsersWithBadgesByIDs extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ListUsersWithBadgesByIDsResponse> {
    UserIDs : number[]; 
  }
  
  export class ListUsersWithBadgesByIDsResponse extends EVA.API.ResponseMessage {
    Users : EVA.Core.UserDto[]; 
  }
  
  export class Login extends EVA.API.RequestMessageGeneric<EVA.Core.Services.LoginResponse> implements EVA.Core.ILoginRequest {
    Username : string; 
    Password : string; 
    OrganizationUnitID? : number; // Int32, nullable
    ApplicationID? : number; // Int32, nullable
    ConfirmationToken : string; 
    AuthenticationToken : string; 
    IdentificationCode : string; 
    RegisterApiKey : boolean; 
    SelectOrganizationByApplicationID : boolean; 
    LanguageID : string; 
    CountryID : string; 
    CustomAuthenticatorType : string; 
    CustomAuthenticateData : any; 
    ClientVersion : string; 
    Context : string; 
    PublicLogin : boolean; 
    UserType : EVA.Framework.UserTypes; 
  }
  
  export class LoginResponse extends EVA.API.ResponseMessage {
    Authentication : EVA.Framework.AuthenticationResults; 
    OrganizationUnits : EVA.Core.OrganizationUnitDto[]; 
    User : EVA.Core.LoggedInUserDto; 
    LoggedInOrganizationID? : number; // Int32, nullable
    IsCustomAuthenticateResult : boolean; 
    AuthenticationToken : string; 
    OrganizationUnitCurrencyID : string; 
  }
  
  export class Logout extends EVA.API.RequestMessageGeneric<EVA.Core.Services.LogoutResponse> {
    ExpireAllSessions : boolean; 
    ClockOut : boolean; 
  }
  
  export class LogoutResponse extends EVA.API.ResponseMessage {
    LogoutSuccesful : boolean; 
  }
  
  export class MakeUserPhoneNumberPrimary extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class ManualCustomer {
    FirstName : string; 
    LastName : string; 
    FiscalID : string; 
  }
  
  export class ListManualDiscountsResponseManualDiscountDto {
    ID : number; // Int32
    BackendID : string; 
    Description : string; 
    MarketingDescription : string; 
    Type : string; 
    NeedsReason : boolean; 
    FixedAmount? : number; // Decimal, nullable
    MaxAmount? : number; // Decimal, nullable
    CurrencyID : string; 
  }
  
  export class ManualLine {
    ProductID? : number; // Int32, nullable
    Description : string; 
    TaxRate : number; // Decimal
    Quantity : number; // Int32
    TotalAmountInTax : number; // Decimal
  }
  
  export class ManualTriggerRecurringTask extends EVA.API.RequestMessageWithEmptyResponse {
    Token : string; 
  }
  
  export class GetAvailablePaymentMethodsResponseMethodModel {
    Name : string; 
    Types : EVA.Core.Services.GetAvailablePaymentMethodsResponseTypeModel[]; 
  }
  
  export class AddLineToPurchaseOrderResponseModel {
    ID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32
    UnitPrice : number; // Decimal
    RequestedDate? : string; // DateTime, nullable
    Reference : string; 
  }
  
  export class GetShipmentLinesResponseModel {
    ID : number; // Int32
    CustomID : string; 
    ProductID : number; // Int32
    Description : string; 
    BackendReference : string; 
    QuantityShipped : number; // Int32
    QuantityDelivered : number; // Int32
    CurrencyID : string; 
    UnitPrice : number; // Decimal
    // Obsolete
    ExchangeRate : number; // Decimal
    // Obsolete
    ForeignUnitPrice : number; // Decimal
    // Obsolete
    ForeignTotalAmount : number; // Decimal
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    UnitPriceInTax : number; // Decimal
    // Obsolete
    ForeignUnitPriceInTax : number; // Decimal
    // Obsolete
    ForeignTotalAmountInTax : number; // Decimal
    TaxRate : number; // Decimal
  }
  
  export class GetSuppliersForOrganizationUnitResponseModel {
    ID : number; // Int32
    Name : string; 
  }
  
  export class ListAvailableTimeZonesResponseModel {
    ID : string; 
    CountryID : string; 
    CountryName : string; 
    Offset : number; // Int32
  }
  
  export class ListBlobsForInvoiceResponseModel {
    Name : string; 
    MimeType : string; 
    BlobID : string; 
    CreationTime : string; // DateTime
  }
  
  export class ListFinancialPeriodExportsResponseModel {
    ID : number; // Int32
    Name : string; 
    Trigger : EVA.Core.FinancialPeriodExportTrigger; 
    Status : EVA.Core.TransputJobStatuses; 
    CreationTime : string; // DateTime
    LastModificationTime? : string; // DateTime, nullable
  }
  
  export class ListOrderLinesInvoiceSummaryResponseModel extends EVA.Core.OrderLineDto {
    QuantityLeftToInvoice : number; // Int32
  }
  
  export class ListOrderShipmentsResponseModel {
    ID : number; // Int32
    BackendID : string; 
    ShipmentDate : string; // DateTime
    TrackingCode : string; 
    TrackingLink : string; 
    ShippedFromOrganizationUnit : EVA.Core.OrganizationUnitDto; 
    ShippedToOrganizationUnit : EVA.Core.OrganizationUnitDto; 
    TotalQuantityShipped : number; // Int32
    TotalQuantityDelivered : number; // Int32
  }
  
  export class ListRelatedOrdersResponseModel {
    RelatedOrderID : number; // Int32
    BackendID : string; 
    CreationTime : string; // DateTime
    TypeID : number; // Int32
    SoldFromOrganizationUnit : EVA.Core.Services.ListRelatedOrdersResponseNamedDto; 
    ShipFromOrganizationUnit : EVA.Core.Services.ListRelatedOrdersResponseNamedDto; 
  }
  
  export class ListReturnableSuppliersForOrderResponseModel {
    ID : number; // Int32
    BackendID : string; 
    Name : string; 
  }
  
  export class ListShipmentLinesToInvoiceResponseModel {
    ID : number; // Int32
    QuantityShipped : number; // Int32
    QuantityDelivered : number; // Int32
    QuantityInvoiced : number; // Int32
    CurrencyID : string; 
    UnitPrice : number; // Decimal
    TaxRate : number; // Decimal
    TotalAmountInvoiced : number; // Decimal
    TotalAmountDelivered : number; // Decimal
    ProductID : number; // Int32
    CustomID : string; 
    ProductName : string; 
  }
  
  export class ListShipmentsToInvoiceResponseModel {
    ID : number; // Int32
    ShipmentDate : string; // DateTime
    BackendID : string; 
    TrackingCode : string; 
    TotalQuantityInvoiced : number; // Int32
    TotalQuantityReceived : number; // Int32
    TotalAmountReceived : number; // Decimal
    TotalAmountInvoiced : number; // Decimal
  }
  
  export class ProduceShipmentDocumentsResponseModel {
    Type : string; 
    Url : string; 
  }
  
  export class ModifyLineActionType extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ModifyLineActionTypeResponse> {
    OrderID? : number; // Int32, nullable
    OrderLineID? : number; // Int32, nullable
    LineActionType? : EVA.Core.LineActionTypes; 
  }
  
  export class ModifyLineActionTypeResponse extends EVA.Core.SimpleShoppingCartResponse {
    Success : boolean; 
    Messages : { [ key : number ] : string }; 
  }
  
  export class ModifyOrderLinePrice extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    OrderLineID : number; // Int32
    UnitPriceInTax : number; // Decimal
    UnitCost? : number; // Decimal, nullable
  }
  
  export class ModifyPurchaseOrderLine extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    UnitPrice? : number; // Decimal, nullable
    RequestedDate? : string; // DateTime, nullable
    Reference : string; 
  }
  
  export class ModifyQuantityOrdered extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ModifyQuantityOrderedResponse> {
    OrderLineID : number; // Int32
    NewQuantityOrdered : number; // Int32
  }
  
  export class ModifyQuantityOrderedResponse extends EVA.Core.SimpleShoppingCartResponse {
    Messages : EVA.Core.Services.ModifyQuantityOrderedResponseQuantityMutationResultMessage[]; 
  }
  
  export class MoveCash extends EVA.API.RequestMessageWithEmptyResponse {
    SourceDeviceID : number; // Int32
    DestinationDeviceID : number; // Int32
    Coins : { [ key : number ] : number }; 
    BankNotes : { [ key : number ] : number }; 
  }
  
  export class MoveCommitments extends EVA.API.RequestMessageWithEmptyResponse {
    Movements : EVA.Core.Services.MoveCommitmentsCommitmentMovement[]; 
  }
  
  export class MoveStock extends EVA.API.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    SourceLabel : number; // Int32
    DestinationLabel : number; // Int32
    Quantity : number; // Int32
    ResourceID? : number; // Int32, nullable
    Remark : string; 
    Reason? : number; // Int32, nullable
  }
  
  export class ListRelatedOrdersResponseNamedDto {
    ID : number; // Int32
    Name : string; 
  }
  
  export class OpenFinancialPeriod extends EVA.API.RequestMessageWithEmptyResponse {
  }
  
  export class OrderBlobDto {
    OrderID : number; // Int32
    OrderLineID? : number; // Int32, nullable
    Name : string; 
    MimeType : string; 
    BlobID : string; 
    CreationTime : string; // DateTime
  }
  
  export class ListOrderExportsForOrderResponseOrderExportDto {
    ID : number; // Int32
    Name : string; 
    Status : EVA.Core.TransputJobStatuses; 
    CreationTime : string; // DateTime
    LastModificationTime? : string; // DateTime, nullable
  }
  
  export class GetOrderExportByIDResponseOrderExportLineDto {
    ID : number; // Int32
    OrderLineID : number; // Int32
    QuantityExported : number; // Int32
    QuantityCancelled : number; // Int32
    QuantityBackordered : number; // Int32
    BackendReference : string; 
    CreationTime : string; // DateTime
    LastModificationTime? : string; // DateTime, nullable
  }
  
  export class OrderLedgerDto {
    ID : number; // Int32
    OrderID : number; // Int32
    OrderLineID? : number; // Int32, nullable
    Type : EVA.Framework.EnumDto; 
    TypeID : number; // Int32
    OldValue : string; 
    NewValue : string; 
    Description : string; 
    CreatedByID : number; // Int32
    CreationTime : string; // DateTime
    CreatedBy : EVA.Core.Services.OrderLedgerDtoUserDto; 
  }
  
  export class GetStockAvailabilityEstimateForOrderResponseOrderLine {
    OrderLineID : number; // Int32
    RequestedDate : string; // DateTime
    QuantityAvailable : number; // Int32
    IsCommitted : boolean; 
    ShipmentDate? : string; // DateTime, nullable
    CanBeFulfilled : boolean; 
    AlternativeDates : EVA.Core.Services.GetStockAvailabilityEstimateForOrderResponseSuggestedAlternativeDate[]; 
  }
  
  export class ProduceShipmentDocumentsOrderLine {
    ID : number; // Int32
    ProductID : number; // Int32
    QuantityToShip : number; // Int32
    TrackAndTraceCode : string; 
    TrackAndTraceLink : string; 
  }
  
  export class OrderLinesReturnSet {
    OrderLineIDs : number[]; 
    RequiredOrderLineIDsToReturn : number[]; 
  }
  
  export class GetOrderSummaryForShippingResponseOrderLineSummary {
    ID : number; // Int32
    ProductID? : number; // Int32, nullable
    TotalQuantityToShip : number; // Int32
    QuantityShipped : number; // Int32
    QuantityOpen : number; // Int32
  }
  
  export class SalesTaxEstimateForOrderResponseOrderLineTaxCalculationModel {
    OrderLineID : number; // Int32
    TaxRate : number; // Decimal
    TaxAmount : number; // Decimal
  }
  
  export class SalesTaxEstimateForOrderResponseOrderLineTaxCalculationTaxAmountModel {
    TaxRate : number; // Decimal
    TaxAmount : number; // Decimal
  }
  
  export class ListGeneralLedgersResponseOrganizationUnit {
    Name : string; 
  }
  
  export class ListOrganizationUnitsResponseOrganizationUnit {
    ID : number; // Int32
    BackendID : string; 
    ParentID? : number; // Int32, nullable
    Name : string; 
    Description : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
    Type : EVA.Framework.OrganizationUnitTypes; 
    Status : EVA.Core.OrganizationUnitStatus; 
    Latitude? : number; // Double, nullable
    Longitude? : number; // Double, nullable
  }
  
  export class GetFlatOrganizationUnitTreeResponseOrganizationUnitDto {
    ID : number; // Int32
    Name : string; 
    BackendID : string; 
    ParentID : number; // Int32
  }
  
  export class OrganizationUnitEnrollmentDto {
    ID : number; // Int32
    Name : string; 
    CountryID : string; 
    BackendID : string; 
  }
  
  export class GetOrganizationUnitOpeningHoursForPeriodResponseOrganizationUnitOpeningHours {
    StartTime? : any; // TimeSpan, nullable
    EndTime? : any; // TimeSpan, nullable
    SpecialReason : string; 
    DayOfWeek? : System.Private.CoreLib.DayOfWeek; 
  }
  
  export class OrganizationUnitTreeDto {
    ID : number; // Int32
    Name : string; 
    Children : EVA.Core.Services.OrganizationUnitTreeDto[]; 
  }
  
  export class ParseBarcode extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ParseBarcodeResponse> {
    Barcode : string; 
  }
  
  export class ParseBarcodeResponse extends EVA.API.ResponseMessage {
    Value : string; 
    Type : string; 
    Data : { [ key : string ] : any }; 
  }
  
  export class GetAvailableRefundPaymentMethodsResponsePaymentMethod {
    Code : string; 
    Transactions : EVA.Core.Services.GetAvailableRefundPaymentMethodsResponseRefundablePaymentTransaction[]; 
  }
  
  export class GetFinancialPeriodInformationResponsePaymentType {
    ID : number; // Int32
    Name : string; 
  }
  
  export class GetFinancialPeriodInformationResponsePaymentTypeSummary {
    Type : EVA.Core.Services.GetFinancialPeriodInformationResponsePaymentType; 
    TotalPaidAmount : number; // Decimal
  }
  
  export class GetPickProductDiscountOptionsForOrderResponsePickProductDiscountOptions {
    Options : number[]; 
    CurrentSelection? : number; // Int32, nullable
    CurrentTier : string; 
  }
  
  export class Ping extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
  }
  
  export class PlaceOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.PlaceOrderResponse> {
    OrderID : number; // Int32
  }
  
  export class PlaceOrderResponse extends EVA.API.ResponseMessage {
    ValidationResult : EVA.Core.OrderExportValidationResult; 
  }
  
  export class PollExternalOrderStatus extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
    Name : string; 
  }
  
  export class PotentialDiscountDto {
    ID : number; // Int32
    BackendID : string; 
    Description : string; 
    MarketingDescription : string; 
    AmountMissing? : number; // Decimal, nullable
    SecondaryProductIDs : number[]; 
    ActionProperties : any; 
    IsAlreadyApplied : boolean; 
  }
  
  export class PriceInfo {
    ProductID : number; // Int32
    PriceListID : number; // Int32
    PriceListUsageTypeID : number; // Int32
    PriceListUsageTypeName : string; 
    CurrencyID : string; 
    TaxRate : number; // Decimal
    Price : number; // Decimal
    PriceInTax : number; // Decimal
    OriginalPrice? : number; // Decimal, nullable
    OriginalPriceInTax? : number; // Decimal, nullable
  }
  
  export class ProcessPeriodClosing extends EVA.API.RequestMessageWithEmptyResponse {
    WorkSet : EVA.Core.PeriodClosingWorkSet; 
  }
  
  export class ProcessPeriodOpening extends EVA.API.RequestMessageWithEmptyResponse {
    WorkSet : EVA.Core.PeriodOpeningWorkSet; 
  }
  
  export class ProcessUnprocessedFinancialEvents extends EVA.API.RequestMessageWithEmptyResponse {
    FinancialPeriodID? : number; // Int32, nullable
    Filter : EVA.Core.ListFinancialEventsFilter; 
  }
  
  export class ProduceDocuments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ProduceDocumentsResponse> {
    PrintInvoice : boolean; 
    EmailInvoice : boolean; 
    PrintReceipt : boolean; 
    DownloadInvoice : boolean; 
    StationID? : number; // Int32, nullable
    OrderID : number; // Int32
    EmailAddress : string; 
    InvoiceID? : number; // Int32, nullable
  }
  
  export class ProduceDocumentsResponse extends EVA.API.ResponseMessage {
    InvoiceUrl : string; 
  }
  
  export class ProduceGiftReceipt extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ProduceGiftReceiptResponse> {
    OrderID : number; // Int32
    Lines : EVA.Core.Services.ProduceGiftReceiptLine[]; 
    StationID? : number; // Int32, nullable
    Name : string; 
    Remark : string; 
  }
  
  export class ProduceGiftReceiptLine {
    OrderLineID : number; // Int32
    Quantity : number; // Int32
  }
  
  export class ProduceGiftReceiptResponse extends EVA.API.ResponseMessage {
    PrintSuccessful : boolean; 
  }
  
  export class ProduceInsuranceDocuments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ProduceInsuranceDocumentsResponse> {
    EmailDocuments : boolean; 
    DownloadDocuments : boolean; 
    PrintDocuments : boolean; 
    IncludeTerms : boolean; 
    OrderID? : number; // Int32, nullable
    OrderLineID? : number; // Int32, nullable
    Copies? : number; // Int32, nullable
    StationID? : number; // Int32, nullable
    EmailAddress : string; 
  }
  
  export class ProduceInsuranceDocumentsResponse extends EVA.API.ResponseMessage {
    ContractUrl : string; 
    TermsUrl : string; 
  }
  
  export class ProduceInvoice extends EVA.API.RequestMessageGeneric<EVA.API.ResourceResponseMessage> {
    OrderID : number; // Int32
    EmailAddress : string; 
    StationID? : number; // Int32, nullable
    EmailInvoice : boolean; 
    DownloadInvoice : boolean; 
    PrintInvoice : boolean; 
    InvoiceID? : number; // Int32, nullable
  }
  
  export class ProduceOrderDocuments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ProduceOrderDocumentsResponse> {
    OrderID? : number; // Int32, nullable
    InvoiceID? : number; // Int32, nullable
    Type : EVA.Core.Services.DocumentTypes; 
    Channel : EVA.Core.TemplateOutputChannel; 
    EmailAddress : string; 
    StationID? : number; // Int32, nullable
  }
  
  export class ProduceOrderDocumentsResponse extends EVA.API.ResponseMessage {
    Url : string; 
  }
  
  export class ProducePackingSlip extends EVA.API.RequestMessageGeneric<EVA.API.ResourceResponseMessage> {
    StationID? : number; // Int32, nullable
    Download : boolean; 
    Print : boolean; 
    ShipmentID : number; // Int32
  }
  
  export class ProducePickSlip extends EVA.API.RequestMessageGeneric<EVA.API.ResourceResponseMessage> {
    StationID? : number; // Int32, nullable
    Download : boolean; 
    Print : boolean; 
    OrderID : number; // Int32
  }
  
  export class ProducePurchaseOrderDocument extends EVA.API.RequestMessageGeneric<EVA.API.ResourceResponseMessage> {
    OrderID : number; // Int32
  }
  
  export class ProduceReceipt extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ProduceReceiptResponse> {
    OrderID : number; // Int32
    StationID? : number; // Int32, nullable
    InvoiceID? : number; // Int32, nullable
  }
  
  export class ProduceReceiptResponse extends EVA.API.ResponseMessage {
    PrintSuccessful : boolean; 
  }
  
  export class ProduceShipmentDocuments extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ProduceShipmentDocumentsResponse> {
    OrderID : number; // Int32
    LinesToShip : EVA.Core.Services.ProduceShipmentDocumentsOrderLine[]; 
    StationID? : number; // Int32, nullable
  }
  
  export class ProduceShipmentDocumentsResponse extends EVA.API.ResponseMessage {
    ShipmentDocuments : EVA.Core.Services.ProduceShipmentDocumentsResponseModel[]; 
  }
  
  export class ProduceTrackingInformation extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ProduceTrackingInformationResponse> {
    OrderID : number; // Int32
  }
  
  export class ProduceTrackingInformationResponse extends EVA.API.ResponseMessage {
    Result : EVA.Core.Services.ProduceTrackingInformationResponseTrackingInformation; 
  }
  
  export class ProductBundlesProductInfo {
    ID : number; // Int32
    CustomID : string; 
    Content : any; 
  }
  
  export class ProductRequirementDto {
    ID : number; // Int32
    ProductID : number; // Int32
    ProductCustomID : string; 
    ProductName : string; 
    Name : string; 
    DataType : EVA.Core.ProductRequirementDataTypes; 
    IsArray : boolean; 
    IsRequired : boolean; 
    Data : any; 
  }
  
  export class GetProductSupplierInfoForProductsResponseProductSupplierInfo {
    ProductID : number; // Int32
    SupplierProductID : number; // Int32
    PreferredMinimumOrderQuantity? : number; // Int32, nullable
    UnitOfMeasures : EVA.Core.Services.GetProductSupplierInfoForProductsResponseProductSupplierInfoUnitOfMeasure[]; 
    UnitCost : number; // Decimal
  }
  
  export class ProductWithResourceDto {
    Product : any; 
    StockLabelID : number; // Int32
    StockLabel : number; // Int32
    QuantityOnHand : number; // Int32
    ResourceID : number; // Int32
    Type : string; 
    Value : string; 
    CreationTime : string; // DateTime
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
  }
  
  export class ProductWithStockDto extends EVA.Core.ProductDto {
    Stocks : EVA.Core.Services.StockDto[]; 
    TotalQuantityOnHand : number; // Int32
  }
  
  export class PropertyGroup {
    PropertyValue : any; 
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    Quantity : number; // Int32
    ChildGroups : EVA.Core.Services.ConfigurableGroup[]; 
  }
  
  export class PushSalesOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.PushSalesOrderResponse> {
    BackendID : string; 
    BackendSystemID : string; 
    CreationTime? : string; // DateTime, nullable
    CurrencyID : string; 
    Remark : string; 
    SoldFromOrganizationUnitBackendID : string; 
    PickupOrganizationUnitBackendID : string; 
    Customer : EVA.Core.Services.PushSalesOrderPushSalesOrderCustomer; 
    ShippingAddress : EVA.Core.Services.PushSalesOrderPushSalesOrderAddress; 
    BillingAddress : EVA.Core.Services.PushSalesOrderPushSalesOrderAddress; 
    Lines : EVA.Core.Services.PushSalesOrderPushSalesOrderLine[]; 
    Payments : EVA.Core.Services.PushSalesOrderPushSalesOrderPayment[]; 
    ShippingInformation : EVA.Core.Services.PushSalesOrderPushSalesOrderShippingInformation; 
    CustomData : { [ key : string ] : any }; 
  }
  
  export class PushSalesOrderPushSalesOrderAddress {
    AddressedTo : string; 
    ZipCode : string; 
    HouseNumber : string; 
    Street : string; 
    City : string; 
    CountryID : string; 
    Region : string; 
  }
  
  export class PushSalesOrderPushSalesOrderCustomer {
    BackendID : string; 
    FirstName : string; 
    LastName : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
    LanguageID : string; 
    CountryID : string; 
    Gender : string; 
  }
  
  export class PushSalesOrderPushSalesOrderLine {
    BackendID : string; 
    CustomID : string; 
    UnitPriceInTax : number; // Decimal
    TaxRate : number; // Decimal
    Quantity : number; // Int32
    Description : string; 
    Type : string; 
    Discounts : EVA.Core.Services.PushSalesOrderPushSalesOrderLineDiscount[]; 
    CustomData : any; 
    RequestedDeliveryDate? : string; // DateTime, nullable
  }
  
  export class PushSalesOrderPushSalesOrderLineDiscount {
    BackendID : string; 
    Description : string; 
    Amount : number; // Decimal
  }
  
  export class PushSalesOrderPushSalesOrderPayment {
    BackendID : string; 
    Method : string; 
    Amount : number; // Decimal
    Data : string; 
  }
  
  export class PushSalesOrderResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    CustomerID? : number; // Int32, nullable
    AlreadyExists : boolean; 
  }
  
  export class PushSalesOrderPushSalesOrderShippingInformation {
    Method : string; 
    UnitPriceInTax : number; // Decimal
    TaxRate : number; // Decimal
  }
  
  export class PushUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.PushUserResponse> {
    BackendSystemID : string; 
    BackendRelationID : string; 
    EmailAddress : string; 
    Gender : string; 
    Initials : string; 
    FirstName : string; 
    LastName : string; 
    PhoneNumber : string; 
    SubscriptionType : EVA.Core.SubscriptionTypes; 
    DateOfBirth? : string; // DateTime, nullable
    Nickname : string; 
    LanguageID : string; 
    CountryID : string; 
    ShippingAddress : EVA.Core.AddressDataDto; 
    BillingAddress : EVA.Core.AddressDataDto; 
  }
  
  export class PushUserResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class ModifyQuantityOrderedResponseQuantityMutationResultMessage {
    Code : string; 
    Message : string; 
  }
  
  export class RaisePurchaseOrderImportedEvent extends EVA.API.RequestMessageWithEmptyResponse {
    PurchaseOrderID? : number; // Int32, nullable
    BackendID : string; 
    BackendSystemID : string; 
    ShipToOrganizationUnitID? : number; // Int32, nullable
  }
  
  export class ReceivePurchaseOrderShipment extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ReceivePurchaseOrderShipmentResponse> {
    ShipmentID : number; // Int32
    QuantityReceived : { [ key : number ] : number }; 
  }
  
  export class ReceivePurchaseOrderShipmentResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
  }
  
  export class ReceiveShipment extends EVA.API.RequestMessageWithEmptyResponse {
    WorkSet : EVA.Core.Services.ReceiveShipmentWorkSet; 
    CompleteShipment? : boolean; 
  }
  
  export class ReceiveShipmentWorkSet {
    Lines : EVA.Core.Services.ReceiveShipmentWorkSetLine[]; 
    ShippedToOrganizationUnitID : number; // Int32
    ShipmentID : number; // Int32
    BackendID : string; 
    Orders : EVA.Core.Services.GetShipmentDetailsOrder[]; 
  }
  
  export class ReceiveShipmentWorkSetLine {
    ProductID : number; // Int32
    ProductPrimitiveName : string; 
    ProductCustomID : string; 
    QuantityOrdered : number; // Int32
    QuantityAlreadyReceived : number; // Int32
    QuantityShipped : number; // Int32
    Receipts : EVA.Core.Services.ReceiveShipmentWorkSetLineReceipt[]; 
    RequiredResourceTypes : EVA.Core.Services.StockResourceTypeDto[]; 
  }
  
  export class ReceiveShipmentWorkSetLineReceipt {
    QuantityReceived : number; // Int32
    Resource : EVA.Core.Services.ReceiveShipmentWorkSetLineResource; 
  }
  
  export class ReceiveShipmentWorkSetLineResource {
    ResourceID? : number; // Int32, nullable
    Resources : { [ key : string ] : string }; 
  }
  
  export class RecoverShoppingCart extends EVA.API.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    ReminderToken : string; 
    SessionID : string; 
  }
  
  export class RefillStockAllocation extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ValueOverride? : number; // Int32, nullable
  }
  
  export class GetAvailableRefundPaymentMethodsResponseRefundablePaymentTransaction {
    ID : number; // Int32
    BackendID : string; 
    PaidAmount : number; // Decimal
    RefundableAmount : number; // Decimal
    ForeignPaidAmount : number; // Decimal
    ForeignRefundableAmount : number; // Decimal
    Type : string; 
  }
  
  export class RemoveProductFromWishList extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
    WishListLineID : number; // Int32
    Quantity : number; // Int32
  }
  
  export class RemovePushNotificationDevice extends EVA.API.RequestMessageWithEmptyResponse {
    DeviceToken : string; 
    BackendSystemID : string; 
  }
  
  export class RemoveUserFromGroup extends EVA.API.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    GroupID : number; // Int32
  }
  
  export class RenderThermalPrintResult extends EVA.API.RequestMessageGeneric<EVA.Core.Services.RenderThermalPrintResultResponse> {
    // The output format. It's possible to provide both HTML and PDF. When Html is specified the response will contain the thermal print result inside the `Html` field.
    OutputFormat : EVA.Core.Services.RenderThermalPrintResultOutputFormat; 
    // The blob that contains the result of the thermal print job. If an incorrect blob is specified, an error will be returned.
    BlobID : string; 
  }
  
  export enum RenderThermalPrintResultOutputFormat {
    Html = 1,
    Pdf = 2,
    Png = 3,
  }
  
  export class RenderThermalPrintResultResponse extends EVA.API.ResponseMessage {
    Html : string; 
    PdfUrl : string; 
    PngUrl : string; 
  }
  
  export class ReplaceEntityTranslation extends EVA.API.RequestMessageWithEmptyResponse {
    EntityID : number; // Int32
    EntityType : string; 
    EntityField : string; 
    LanguageID : string; 
    CountryID : string; 
    Value : string; 
  }
  
  export class ReplaceStringTranslation extends EVA.API.RequestMessageWithEmptyResponse {
    Key : string; 
    LanguageID : string; 
    CountryID : string; 
    Value : string; 
  }
  
  export class RepostFinancialPeriod extends EVA.API.RequestMessageWithEmptyResponse {
    FinancialPeriodID : number; // Int32
  }
  
  export class ReprintThermalPrintResult extends EVA.API.RequestMessageWithEmptyResponse {
    // The blob that contains the result of the thermal print job. If an incorrect blob is specified, an error will be returned.
    BlobID : string; 
    StationID : number; // Int32
  }
  
  export class RequestDeviceAuthenticationToken extends EVA.API.RequestMessageGeneric<EVA.Core.Services.RequestDeviceAuthenticationTokenResponse> {
  }
  
  export class RequestDeviceAuthenticationTokenResponse extends EVA.API.ResponseMessage {
    AuthenticationToken : string; 
  }
  
  export class RequestInsurancesForOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
  }
  
  export class RequestPasswordResetToken extends EVA.API.RequestMessageWithEmptyResponse {
    EmailAddress : string; 
    Context : string; 
    ApplicationID? : number; // Int32, nullable
  }
  
  export class RequestPaymentUpdate extends EVA.API.RequestMessageGeneric<EVA.Core.Services.RequestPaymentUpdateResponse> {
    PaymentTransactionID : number; // Int32
  }
  
  export class RequestPaymentUpdateResponse extends EVA.API.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto; 
  }
  
  export class RequestThirdPartyLogin extends EVA.API.RequestMessageGeneric<EVA.Core.Services.RequestThirdPartyLoginResponse> {
    Code : string; 
    ReturnUrlSuccess : string; 
    ReturnUrlError : string; 
  }
  
  export class RequestThirdPartyLoginResponse extends EVA.API.ResponseMessage {
    RedirectUrl : string; 
  }
  
  export class RequeueErrorMessage extends EVA.API.RequestMessageWithEmptyResponse {
    MessageQueueErrorID : number; // Int32
    MessageQueueErrorIDs : number[]; 
  }
  
  export class ResendVerifyEmailAddress extends EVA.API.RequestMessageWithEmptyResponse {
    EmailAddress : string; 
  }
  
  export class ReserveOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    // Station to print the receipt on
    StationID? : number; // Int32, nullable
  }
  
  export class ResetFinancialEvents extends EVA.API.RequestMessageWithEmptyResponse {
    Filter : EVA.Core.ListFinancialEventsFilter; 
  }
  
  export class ResetUserPassword extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ResetUserPasswordResponse> {
    Token : string; 
    NewPassword : string; 
  }
  
  export class ResetUserPasswordResponse extends EVA.API.ResponseMessage {
    EmailAddress : string; 
  }
  
  export class RetryFinancialPeriodExport extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Force : boolean; 
  }
  
  export class RetryOrderExport extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Force : boolean; 
  }
  
  export class ReturnableStatusForOrderLine {
    OrderLineID : number; // Int32
    ReturnableQuantity : number; // Int32
    IsReturnable : boolean; 
    IsReturnableWithParent : boolean; 
  }
  
  export class RewriteUrl extends EVA.API.RequestMessageGeneric<EVA.Core.Services.RewriteUrlResponse> {
    Url : string; 
  }
  
  export class RewriteUrlResponse extends EVA.API.ResponseMessage {
    Url : string; 
  }
  
  export class GetAvailableServiceDetailsResponseRoute {
    Method : string; 
    Path : string; 
  }
  
  export class SalesTaxEstimateForOrderResponse extends EVA.API.ResponseMessage {
    IsSuccess : boolean; 
    TotalTaxAmount : number; // Decimal
    TaxTable : EVA.Core.Services.SalesTaxEstimateForOrderResponseOrderLineTaxCalculationTaxAmountModel[]; 
    OrderLines : EVA.Core.Services.SalesTaxEstimateForOrderResponseOrderLineTaxCalculationModel[]; 
  }
  
  export class ScanStation extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SelectStationResponse> {
    Barcode : string; 
  }
  
  export class SearchBrands extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SearchBrandsResponse> {
    PageSize? : number; // Int32, nullable
    Query : string; 
  }
  
  export class SearchBrandsResponse extends EVA.API.ResponseMessage {
    Brands : EVA.Core.BrandNameInfo[]; 
  }
  
  export class SearchOrders extends EVA.API.PagedResultRequest<EVA.Core.Services.SearchOrdersResponse> {
    Query : string; 
    PaymentStatus : EVA.Core.PaymentStatus; 
    IsPlaced? : boolean; 
    IsShipped? : boolean; 
    IsCompleted? : boolean; 
    HasShipLines? : boolean; 
    HasDeliveryLines? : boolean; 
    HasReserveLines? : boolean; 
    HasOrderLines? : boolean; 
    StartTime? : string; // DateTime, nullable
    EndTime? : string; // DateTime, nullable
    StartRequestedDate? : string; // DateTime, nullable
    EndRequestedDate? : string; // DateTime, nullable
    StartShipmentDate? : string; // DateTime, nullable
    EndShipmentDate? : string; // DateTime, nullable
    OrderIDs : number[]; 
    OrderLineID? : number; // Int32, nullable
    InvoiceNumber : string; 
    CompanyName : string; 
    ProductID? : number; // Int32, nullable
    IsReserved? : boolean; 
    IsOrder? : boolean; 
    IsInvoiced? : boolean; 
    IsEmpty? : boolean; 
    IsExported? : boolean; 
    PaymentTypeID? : number; // Int32, nullable
    PaymentTypeName : string; 
    OrganizationUnitID? : number; // Int32, nullable
    MinTotalAmountInTax? : number; // Decimal, nullable
    MaxTotalAmountInTax? : number; // Decimal, nullable
    ProductVariation : { [ key : string ] : string[] }; 
    Data : { [ key : string ] : EVA.Core.OrderSearchDataFilterModel }; 
    HasReturns? : boolean; 
    HasCustomer? : boolean; 
    OrderType : EVA.Core.OrderTypes; 
    ShipFromOrganizationUnitID? : number; // Int32, nullable
    CustomerID? : number; // Int32, nullable
    CustomerReference : string; 
    ShipToOrganizationUnitID? : number; // Int32, nullable
    SoldFromOrganizationUnitID? : number; // Int32, nullable
    SoldToOrganizationUnitID? : number; // Int32, nullable
    OriginatingOrganizationUnitID? : number; // Int32, nullable
    PickupOrganizationUnitID? : number; // Int32, nullable
    ShippingOrganizationUnitID? : number; // Int32, nullable
    Properties : number[]; 
    CustomStatus : number[]; 
    UserAgentApplication : string; 
  }
  
  export class SearchOrdersResponse extends EVA.API.ResponseMessage {
    Result : EVA.Framework.PagedResultGeneric<EVA.Core.OrderSearchResultItem>; 
    ProductVariations : { [ key : string ] : { [ key : string ] : number } }; 
  }
  
  export class SearchProducts extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SearchProductsResponse> {
    Query : string; 
    Filters : { [ key : string ] : EVA.Core.FilterModel }; 
    AggregationState : string; 
    AggregationOptions : { [ key : string ] : EVA.Core.AggregationFilterModel }; 
    PageSize? : number; // Int32, nullable
    Page? : number; // Int32, nullable
    Sort : EVA.Framework.SortFieldDescriptor[]; 
    SearchStrategyCode : string; 
    IncludedFields : string[]; 
  }
  
  export class SearchProductsResponse extends EVA.API.ResponseMessage {
    Products : any[]; 
    AggregationState : string; 
    Aggregations : any; 
    AggregationOptions : { [ key : string ] : EVA.Core.AggregationFilterModel }; 
    Page : number; // Int32
    PageSize : number; // Int32
    Total : number; // Int64
    Sort : EVA.Framework.SortFieldDescriptor[]; 
  }
  
  export class SearchStockByFields extends EVA.API.PagedResultRequest<EVA.Core.Services.SearchStockResponse> {
    Query : string; 
    ProductID? : number; // Int32, nullable
    BackendID : string; 
    CustomID : string; 
  }
  
  export class SearchStockResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.ProductWithStockDto> {
  }
  
  export class SearchUsers extends EVA.API.PagedResultRequest<EVA.Core.Services.SearchUsersResponse> {
    UserIDs : number[]; 
    EmailAddress : string; 
    Name : string; 
    SearchQuery : string; 
    Types : EVA.Framework.UserTypes; 
    ZipCode : string; 
    PhoneNumber : string; 
    EmployeeNumber : string; 
    PrimaryOrganizationUnitID? : number; // Int32, nullable
    AssignedEmployeeID? : number; // Int32, nullable
  }
  
  export class SearchUsersResponse extends EVA.API.PagedResultResponse<EVA.Core.Services.SearchUsersResponseUserSearchDto> {
  }
  
  export class GetAvailableServiceDetailsResponseSecurityInfo {
    RequiresAuthentication : boolean; 
    RequiredFunctionalities : EVA.Core.Services.GetAvailableServiceDetailsResponseFunctionalityInfo[]; 
    RequiredUserType : EVA.Framework.UserTypes; 
    AllowPublic : boolean; 
  }
  
  export class SelectStation extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SelectStationResponse> {
    StationID : number; // Int32
  }
  
  export class SelectStationResponse extends EVA.API.ResponseMessage {
    Station : EVA.Core.StationDto; 
    HasPrinterDevice : boolean; 
    HasPinDevice : boolean; 
    HasReceiptPrinterDevice : boolean; 
  }
  
  export class SendConfigurationPage extends EVA.API.RequestMessageWithEmptyResponse {
    OrganizationUnitID? : number; // Int32, nullable
  }
  
  export class SendContactForm extends EVA.API.RequestMessageWithEmptyResponse {
    Type : string; 
    Properties : { [ key : string ] : string }; 
  }
  
  export class SendPushNotificationBatch extends EVA.API.RequestMessageWithEmptyResponse {
    Title : string; 
    Message : string; 
    UserIDs : number[]; 
    Priority : EVA.Core.PushNotificationPriority; 
    TimeToLive? : number; // Int32, nullable
    Sound : string; 
    SilentNotification : boolean; 
    Payload : any; 
  }
  
  export class GetAvailableServicesResponseService {
    Name : string; 
    Type : string; 
    Namespace : string; 
    AllowPublic : boolean; 
  }
  
  export class SetCustomerReferencesOnOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    CustomerReference : string; 
    CustomerOrderID : string; 
  }
  
  export class SetDefaultBillingAddress extends EVA.API.RequestMessageWithEmptyResponse {
    AddressBookID : number; // Int32
  }
  
  export class SetDefaultShippingAddress extends EVA.API.RequestMessageWithEmptyResponse {
    AddressBookID : number; // Int32
  }
  
  export class SetDeliveryOrderData extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
    DeliveryOrderData : EVA.Core.DeliveryOrderData; 
  }
  
  export class SetFiscalOrderData extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    FiscalID : string; 
    VatNumber : string; 
  }
  
  export class SetGiftWrappingOptionsOnOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    WrapOrder : boolean; 
    WrapIndividually : boolean; 
    // Obsolete: replaced with GiftWraps
    Lines : EVA.Core.Services.WrapLine[]; 
    GiftWraps : EVA.Core.Services.GiftWrap[]; 
  }
  
  export class SetPickProductDiscountOptionsForOrderLine extends EVA.API.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    Selection? : number; // Int32, nullable
  }
  
  export class SetPickupOrganizationUnit extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    OrderID? : number; // Int32, nullable
    SessionID : string; 
    OrganizationUnitID : number; // Int32
  }
  
  export class SetRemarkOnOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    Remark : string; 
  }
  
  export class SetRequestedDate extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    OrderLineID? : number; // Int32, nullable
    RequestedDate? : string; // DateTime, nullable
    Quantity? : number; // Int32, nullable
  }
  
  export class SetShipmentSettings extends EVA.API.RequestMessageWithEmptyResponse {
    OrganizationUnitID? : number; // Int32, nullable
    DefaultReceiveMethod : EVA.Core.ShipmentReceiveMethods; 
  }
  
  export class SetShippingMethod extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    OrderLineID? : number; // Int32, nullable
    ShippingMethodID : number; // Int32
    RequestedDeliveryDate? : string; // DateTime, nullable
  }
  
  export class SetTransportOrderLineData extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderLineID : number; // Int32
    OrderLineIDs : number[]; 
    TransportOrderLineData : EVA.Core.TransportOrderLineData; 
  }
  
  export class SetUserConsignment extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    UserID : number; // Int32
    UseConsignment : boolean; 
  }
  
  export class SetWarehouseOrderData extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
    WarehouseOrderData : EVA.Core.WarehouseOrderData; 
  }
  
  export class SetWishListOrderLineData extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
    OrderLineID : number; // Int32
    IsHidden : boolean; 
  }
  
  export class ShipOrderShipmentOrderLine {
    OrderLineID : number; // Int32
    QuantityShipped? : number; // Int32, nullable
    DeliveryNoteNumber : string; 
    ShipmentBackendID : string; 
    TrackingCode : string; 
    TrackingLink : string; 
  }
  
  export class ShipOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ShipOrderResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Lines : EVA.Core.Services.ShipOrderShipmentOrderLine[]; 
    Force : boolean; 
    FinalShipment : boolean; 
  }
  
  export class ShipOrderLines extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    ShipmentBackendID : string; 
    TrackingCode : string; 
    ShipmentDate : string; // DateTime
    Lines : EVA.Core.Services.ShipOrderLinesLine[]; 
  }
  
  export class ShipOrderResponse extends EVA.API.ResponseMessage {
    ShipmentIDs : number[]; 
    ShippedOrderLineIDs : number[]; 
    Messages : EVA.Core.ConfirmShipmentResultMessage[]; 
  }
  
  export class ShipPurchaseOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ShipPurchaseOrderResponse> {
    OrderID : number; // Int32
    BackendID : string; 
    TrackingCode : string; 
    ShipmentDate : string; // DateTime
    Lines : EVA.Core.Services.ShipPurchaseOrderLine[]; 
  }
  
  export class ShipPurchaseOrderLine {
    OrderLineID : number; // Int32
    QuantityToShip : number; // Int32
  }
  
  export class ShipPurchaseOrderResponse extends EVA.API.ResponseMessage {
    ShipmentID : number; // Int32
  }
  
  export class ShopInfo {
    ID : number; // Int32
    Name : string; 
    Address : EVA.Core.AddressDto; 
    PhoneNumber : string; 
    Latitude : number; // Double
    Longitude : number; // Double
    Distance : number; // Int32
  }
  
  export class SimpleOrderLine {
    OrderLineID : number; // Int32
    ProductID? : number; // Int32, nullable
    Properties : any; 
    Description : string; 
    Quantity : number; // Int32
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
  }
  
  export class SimpleUserDto {
    ID : number; // Int32
    FirstName : string; 
    LastName : string; 
  }
  
  export class SplitOrderLine extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SplitOrderLineResponse> {
    OrderLineID : number; // Int32
    QuantityToSplit : number; // Int32
  }
  
  export class SplitOrderLineResponse extends EVA.API.ResponseMessage {
    OrderLineID : number; // Int32
  }
  
  export class StartCloseCashJournal extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StartCloseCashJournalResponse> {
    DeviceID : number; // Int32
  }
  
  export class StartCloseCashJournalResponse extends EVA.API.ResponseMessage {
    CashJournalDetails : EVA.Core.CashJournalDetailsModel; 
  }
  
  export class StartOpenCashJournal extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StartOpenCashJournalResponse> {
    DeviceID : number; // Int32
  }
  
  export class StartOpenCashJournalResponse extends EVA.API.ResponseMessage {
    CurrencyID : string; 
    CountryID : string; 
    AvailableCoins : number[]; 
    AvailableBankNotes : number[]; 
    PreviousCashJournal : EVA.Core.Services.StartOpenCashJournalResponseCashJournal; 
  }
  
  export class StartPeriodClosing extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StartPeriodClosingResponse> {
  }
  
  export class StartPeriodClosingResponse extends EVA.API.ResponseMessage {
    WorkSet : EVA.Core.PeriodClosingWorkSet; 
  }
  
  export class StartPeriodOpening extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StartPeriodOpeningResponse> {
  }
  
  export class StartPeriodOpeningResponse extends EVA.API.ResponseMessage {
    WorkSet : EVA.Core.PeriodOpeningWorkSet; 
  }
  
  export class StockDto {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    StockLabel : number; // Int32
    StockLabelID : number; // Int32
    QuantityOnHand : number; // Int32
    QuantityCommitted : number; // Int32
    QuantityAvailable : number; // Int32
    Remark : string; 
  }
  
  export class GetStockLabelsResponseStockLabelDto {
    ID : number; // Int32
    Name : string; 
    AllowedTypes : string[]; 
    AllowedDirections : string[]; 
    Description : string; 
  }
  
  export class GetStockByStockLabelForProductsResponseStockLabelStock {
    StockLabelID : number; // Int32
    QuantityOnHand : number; // Int32
  }
  
  export class StockNotificationResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class StockResourceDto {
    ID : number; // Int32
    Lines : EVA.Core.Services.StockResourceLineDto[]; 
  }
  
  export class StockResourceLineDto {
    Type : string; 
    Value : string; 
  }
  
  export class StockResourceTypeDto {
    Name : string; 
    IsUnique : boolean; 
  }
  
  export class StoreAndAttachBlobToOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.StoreAndAttachBlobToOrderResponse> {
    Name : string; 
    OrderID? : number; // Int32, nullable
    OrderLineID? : number; // Int32, nullable
    Category : string; 
    OriginalName : string; 
    MimeType : string; 
    Data : string; 
  }
  
  export class StoreAndAttachBlobToOrderResponse extends EVA.API.ResponseMessage {
    Guid : string; 
    Url : string; 
  }
  
  export class Subscribe extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SubscribeToNewsletterResponse> {
    EmailAddress : string; 
    Type : EVA.Core.SubscriptionTypes; 
    UserID? : number; // Int32, nullable
  }
  
  export class SubscribeToFeed extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SubscribeToFeedResponse> {
    Name : string; 
    WebhookUrl : string; 
  }
  
  export class SubscribeToFeedResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
  }
  
  export class SubscribeToNewsletter extends EVA.API.RequestMessageGeneric<EVA.Core.Services.SubscribeToNewsletterResponse> {
    EmailAddress : string; 
    UserID? : number; // Int32, nullable
  }
  
  export class SubscribeToNewsletterResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
    NeedsConfirmation : boolean; 
  }
  
  export class GetStockAvailabilityEstimateForOrderResponseSuggestedAlternativeDate {
    Date : string; // DateTime
    QuantityAvailable : number; // Int32
  }
  
  export class SupplierCreatePurchaseOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.CreatePurchaseOrderResponse> {
    ShipFromOrganizationUnitBackendID : string; 
    ShipToOrganizationUnitBackendID : string; 
    BackendID : string; 
    BackendSystemID : string; 
    ExpectedDeliveryDate? : string; // DateTime, nullable
    Lines : EVA.Core.Services.SupplierCreatePurchaseOrderSupplierCreatePurchaseOrderLine[]; 
  }
  
  export class SupplierCreatePurchaseOrderSupplierCreatePurchaseOrderLine {
    CustomID : string; 
    Quantity : number; // Int32
  }
  
  export class SupplierShipPurchaseOrder extends EVA.API.RequestMessageWithEmptyResponse {
    BackendID : string; 
    BackendSystemID : string; 
    Confirmations : EVA.Core.Services.SupplierShipPurchaseOrderConfirmation[]; 
  }
  
  export class SupplierShipPurchaseOrderConfirmation {
    BackendID : string; 
    TrackingCode : string; 
    TrackingLink : string; 
    ExpectedDeliveryDate? : string; // DateTime, nullable
    Lines : EVA.Core.Services.SupplierShipPurchaseOrderConfirmationLine[]; 
  }
  
  export class SupplierShipPurchaseOrderConfirmationLine {
    CustomID : string; 
    Quantity : number; // Int32
  }
  
  export class SupplierUpdatePurchaseOrder extends EVA.API.RequestMessageWithEmptyResponse {
    BackendID : string; 
    BackendSystemID : string; 
    Lines : EVA.Core.Services.SupplierUpdatePurchaseOrderSupplierUpdatePurchaseOrderLine[]; 
  }
  
  export class SupplierUpdatePurchaseOrderSupplierUpdatePurchaseOrderLine {
    CustomID : string; 
    Quantity : number; // Int32
  }
  
  export class ListSuspendedOrdersResponseSuspendedOrderDto {
    OrderID : number; // Int32
    Description : string; 
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    CurrencyID : string; 
    CustomerName : string; 
    SuspendedByName : string; 
    SuspensionTime : string; // DateTime
  }
  
  export class SuspendOrder extends EVA.API.RequestMessageWithEmptyResponse {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Description : string; 
    StationID? : number; // Int32, nullable
    PrintReceipt : boolean; 
  }
  
  export class SyncStationSyncDevice {
    Id : string; 
    Name : string; 
    DeviceTypes : string[]; 
    Address : string; 
    FormatType : string; 
    UseDirectConnection : boolean; 
    EcrID : string; 
    HardwareID : string; 
  }
  
  export class SyncStation extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
    OrganizationUnitID? : number; // Int32, nullable
    Name : string; 
    PublicIpAddress : string; 
    Devices : EVA.Core.Services.SyncStationSyncDevice[]; 
  }
  
  export class ListAvailableRecurringTasksResponseTaskPluginDto {
    Name : string; 
    FullName : string; 
    Description : string; 
    AvailableSettings : EVA.Core.Services.TaskPluginSettings[]; 
    DefaultName : string; 
    DefaultCron : string; 
  }
  
  export class TaskPluginSettings {
    Key : string; 
    Description : string; 
    Required : boolean; 
    Default : any; 
  }
  
  export class TaxCodeItem {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    LedgerClassID : string; 
    BackendID : string; 
  }
  
  export class GetStockAvailabilityTimelineResponseTimelineItem {
    OrganizationUnitID : number; // Int32
    OrganizationUnitName : string; 
    Type : EVA.Core.Services.AvailabilityTimelineItemTypes; 
    Date : string; // DateTime
    OrderID? : number; // Int32, nullable
    OrderLineID? : number; // Int32, nullable
    ProductID : number; // Int32
    DeltaQuantityOnHand : number; // Int32
    DeltaQuantityCommitted : number; // Int32
    CumulativeSumQuantityCommitted : number; // Int32
    CumulativeSumQuantityOnHand : number; // Int32
    CumulativeSumQuantityAvailable : number; // Int32
    RequestedDate? : string; // DateTime, nullable
    OrderBackendID : string; 
  }
  
  export class ProduceTrackingInformationResponseTrackingInformation {
    Link : string; 
    Code : string; 
  }
  
  export class TransferOrder extends EVA.API.RequestMessageWithEmptyResponse {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
  }
  
  export class TriggerRecurringTask extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
  }
  
  export class GetAvailableServiceDetailsResponseTypeDefinition {
    Name : string; 
    Description : string; 
    Namespace : string; 
    Type : string; 
    Optional : boolean; 
    Fields : EVA.Core.Services.GetAvailableServiceDetailsResponseTypeDefinition[]; 
  }
  
  export class GetAvailablePaymentMethodsResponseTypeModel {
    ID : number; // Int32
    Name : string; 
    Code : string; 
    Data : any; 
  }
  
  export class UncommitOrderLines extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    OrderLineIDs : number[]; 
  }
  
  export class GetProductSupplierInfoForProductsResponseProductSupplierInfoUnitOfMeasure {
    UnitOfMeasureID : number; // Int32
    UnitOfMeasureName : string; 
    Quantity : number; // Int32
  }
  
  export class Unsubscribe extends EVA.API.RequestMessageGeneric<EVA.Core.Services.UnsubscribeFromNewsletterResponse> {
    EmailAddress : string; 
    Type : EVA.Core.SubscriptionTypes; 
    UserID? : number; // Int32, nullable
  }
  
  export class UnsubscribeFromFeed extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    ID : number; // Int32
  }
  
  export class UnsubscribeFromNewsletter extends EVA.API.RequestMessageGeneric<EVA.Core.Services.UnsubscribeFromNewsletterResponse> {
    EmailAddress : string; 
    UserID? : number; // Int32, nullable
  }
  
  export class UnsubscribeFromNewsletterResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
  }
  
  export class UpdateAddress extends EVA.API.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    BillToShipping : boolean; 
    ShipToAddress : EVA.Core.AddressDataDto; 
    BillToAddress : EVA.Core.AddressDataDto; 
  }
  
  export class UpdateAddressBookItem extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Description : string; 
    Address : EVA.Core.AddressDataDto; 
  }
  
  export class UpdateCashExpenseType extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Description : string; 
    LedgerClassID : string; 
    BackendID : string; 
    AmountType : EVA.Core.CashExpenseAmountTypes; 
    OrganizationUnitSetID? : number; // Int32, nullable
  }
  
  export class UpdateCompanyForUser extends EVA.API.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Name : string; 
    RegistrationNumber : string; 
    RegistrationCity : string; 
    RegistrationCountryID : string; 
    VatNumber : string; 
    LegalFormID : number; // Int32
    EstablishedDate? : string; // DateTime, nullable
    ContactEmailAddress : string; 
    ContactPhoneNumber : string; 
    AccountHolderName : string; 
    IBAN : string; 
    BIC : string; 
    DeliveryAddress : EVA.Core.AddressDto; 
    InvoiceAddress : EVA.Core.AddressDto; 
    ReturnsAddress : EVA.Core.AddressDto; 
    VisitorsAddress : EVA.Core.AddressDto; 
  }
  
  export class UpdateContractNumber extends EVA.API.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    ContractNumber : string; 
  }
  
  export class UpdateCurrency extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
    Name : string; 
    ExchangeRate? : number; // Decimal, nullable
  }
  
  export class UpdateDevice extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string; 
    TypeID : number; // Int32
    NetworkName : string; 
    IpAddress : string; 
    StationID? : number; // Int32, nullable
    AssemblyName : string; 
    EcrID : string; 
    HardwareID : string; 
    ProxyID : string; 
    OrganizationUnitID? : number; // Int32, nullable
    BackendID : string; 
  }
  
  export class UpdateInterbranchOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    OrganizationUnitID : number; // Int32
  }
  
  export class UpdateInvoice extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    InvoiceDate : string; // DateTime
    PaymentTermStartDate? : string; // DateTime, nullable
    PaymentTermDueDate? : string; // DateTime, nullable
    InvoiceNumber : string; 
    Description : string; 
    OrganizationUnitID : number; // Int32
    SupplierOrganizationUnitID : number; // Int32
    HoldStatusID? : number; // Int32, nullable
    AdditionalAmounts : EVA.Core.Services.InvoiceAdditionalAmountDto[]; 
    Blobs : EVA.Core.Services.InvoiceBlobDto[]; 
    OriginalTotalAmount? : number; // Decimal, nullable
    FiscalID : string; 
  }
  
  export class UpdateInvoiceHoldStatus extends EVA.API.RequestMessageWithEmptyResponse {
    InvoiceID : number; // Int32
    HoldStatusID? : number; // Int32, nullable
  }
  
  export class UpdateInvoiceLine {
    OrderLineID? : number; // Int32, nullable
    ShipmentLineID? : number; // Int32, nullable
    QuantityToInvoice : number; // Int32
    Amount : number; // Decimal
    TaxRate? : number; // Decimal, nullable
  }
  
  export class UpdateInvoiceLines extends EVA.API.RequestMessageWithEmptyResponse {
    InvoiceID : number; // Int32
    Lines : EVA.Core.Services.UpdateInvoiceLine[]; 
  }
  
  export class UpdateOrderAddresses extends EVA.API.RequestMessageGeneric<EVA.Core.Services.UpdateOrderAddressesResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    CopyShippingAddressFromCustomer : boolean; 
    CopyBillingAddressFromCustomer : boolean; 
    ShipToAddress : EVA.Core.AddressDataDto; 
    BillToAddress : EVA.Core.AddressDataDto; 
  }
  
  export class UpdateOrderAddressesResponse extends EVA.API.ResponseMessage {
    CreditcardAllowed : boolean; 
    ShipToAddress : EVA.Core.AddressDto; 
    BillToAddress : EVA.Core.AddressDto; 
  }
  
  export class UpdateOrderAddressResponse extends EVA.API.ResponseMessage {
    ShippingAddress : EVA.Core.AddressDto; 
    BillingAddress : EVA.Core.AddressDto; 
  }
  
  export class UpdateOrderBillingAddress extends EVA.API.RequestMessageGeneric<EVA.Core.Services.UpdateOrderAddressResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Address : EVA.Core.AddressDto; 
    AddressBookID? : number; // Int32, nullable
  }
  
  export class UpdateOrderCurrency extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID? : number; // Int32, nullable
    SessionID : string; 
    CurrencyID : string; 
  }
  
  export class UpdateOrderShippingAddress extends EVA.API.RequestMessageGeneric<EVA.Core.Services.UpdateOrderAddressResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Address : EVA.Core.AddressDto; 
    AddressBookID? : number; // Int32, nullable
  }
  
  export class UpdateOrganizationOpeningHours extends EVA.API.UpdateRequest<EVA.Core.OpeningHoursDto> implements EVA.API.IRequestRespondsAs<EVA.Core.Services.UpdateOrganizationOpeningHoursResponse> {
    openingHoursDto : EVA.Core.OpeningHoursDto[]; 
  }
  
  export class UpdateOrganizationOpeningHoursResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
  }
  
  export class UpdateOrganizationUnit extends EVA.API.UpdateRequest<EVA.Core.OrganizationUnitDto> implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
    OrganizationUnits : EVA.Core.OrganizationUnitDto[]; 
    AllowTypeUpdate : boolean; 
  }
  
  export class UpdateOrganizationUnit2 extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    OpeningHours : EVA.Core.OpeningHoursDto[]; 
    Address : EVA.Core.AddressDataDto; 
    StatusID : number; // Int32
    Latitude : number; // Double
    Longitude : number; // Double
    BankAccount : string; 
    CocNumber : string; 
    VatNumber : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
    CompanyID? : number; // Int32, nullable
  }
  
  export class UpdateOrganizationUnitSettings extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ParentID? : number; // Int32, nullable
    BackendID : string; 
    BackendRelationID : string; 
    BackendCompanyID : string; 
    BranchNumber : string; 
    GlobalLocationNumber : string; 
    RegisterCashLimit? : number; // Decimal, nullable
    SafeCashLimit? : number; // Decimal, nullable
    CashHandlerID? : number; // Int32, nullable
    TypeID : number; // Int32
    Subnet : string; 
    UseForAccounting : boolean; 
    AttachedToUserID? : number; // Int32, nullable
    IpAddress : string; 
    CountryID : string; 
    LanguageID : string; 
    CurrencyID : string; 
    CostPriceCurrencyID : string; 
    TimeZone : string; 
    AssortmentID? : number; // Int32, nullable
    RoleSetID : number; // Int32
  }
  
  export class UpdateOrganizationUnitSupplier extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Type : EVA.Core.OrganizationUnitSupplierTypes; 
  }
  
  export class UpdateProductAvailabilityData extends EVA.API.UpdateRequest<EVA.Core.ProductAvailabilityDataDto> implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class UpdateProductBundle extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    BackendID : string; 
    BundleProductID? : number; // Int32, nullable
    Lines : EVA.Core.Services.UpdateProductBundleLine[]; 
  }
  
  export class UpdateProductBundleLine {
    ID : number; // Int32
    Description : string; 
    DefaultProductID? : number; // Int32, nullable
    BackendID : string; 
    Type : EVA.Core.ProductBundleLineTypes; 
    Options : EVA.Core.Services.UpdateProductBundleLineOption[]; 
  }
  
  export class UpdateProductBundleLineOption {
    ProductID : number; // Int32
  }
  
  export class UpdateProductRequirement extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ProductID : number; // Int32
    Name : string; 
    DataType : EVA.Core.ProductRequirementDataTypes; 
    IsArray : boolean; 
    IsRequired : boolean; 
    Data : any; 
  }
  
  export class UpdateProductRequirementValuesForOrderLine extends EVA.API.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    Values : { [ key : number ] : any }; 
  }
  
  export class UpdateRecurringTask extends EVA.API.RequestMessageWithEmptyResponse {
    ID : string; 
    FullName : string; 
    Cron : string; 
    Arguments : { [ key : string ] : string }; 
  }
  
  export class UpdateReturnToSupplierOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    ReasonID? : number; // Int32, nullable
    ShipToOrganizationUnitID? : number; // Int32, nullable
  }
  
  export class UpdateRobotsTxt extends EVA.API.RequestMessageWithEmptyResponse {
    Robots : string; 
  }
  
  export class UpdateSerialNumber extends EVA.API.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    SerialNumber : string; 
  }
  
  export class UpdateStation extends EVA.API.UpdateRequest<EVA.Core.StationDto> implements EVA.API.IRequestRespondsAs<EVA.API.EmptyResponseMessage> {
  }
  
  export class UpdateStock extends EVA.API.RequestMessageWithEmptyResponse {
    OrganizationUnitID? : number; // Int32, nullable
    Stock : { [ key : number ] : number }; 
  }
  
  export class UpdateStockAllocationRule extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Value? : number; // Int32, nullable
    ValueType : EVA.Core.StockAllocationRuleValueTypes; 
    RefillPeriodInDays? : number; // Int32, nullable
  }
  
  export class UpdateSubscription extends EVA.API.RequestMessageWithEmptyResponse {
    Type : EVA.Core.SubscriptionTypes; 
    UserID? : number; // Int32, nullable
  }
  
  export class UpdateTaxRate extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    ID : number; // Int32
    CountryID : string; 
    TaxCodeID : number; // Int32
    Rate : number; // Decimal
    StartDate? : string; // DateTime, nullable
    EndDate? : string; // DateTime, nullable
  }
  
  export class UpdateUser extends EVA.API.RequestMessageGeneric<EVA.Core.Services.UpdateUserResponse> {
    ID : number; // Int32
    BackendRelationID : string; 
    Initials : string; 
    FirstName : string; 
    LastName : string; 
    DateOfBirth? : string; // DateTime, nullable
    PlaceOfBirth : string; 
    Gender : string; 
    LanguageID : string; 
    CountryID : string; 
    Nickname : string; 
    BankAccount : string; 
    PhoneNumber : string; 
    TimeZone : string; 
    FiscalID : string; 
    SocialSecurityNumber : string; 
  }
  
  export class UpdateUserDebtorData extends EVA.API.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    PaymentTerms : string; 
    CreditLimit? : number; // Decimal, nullable
    AssignedToUserID? : number; // Int32, nullable
    ColloPrice? : number; // Decimal, nullable
    PalletPrice? : number; // Decimal, nullable
    OversizedPrice? : number; // Decimal, nullable
    IsTaxExempt : boolean; 
  }
  
  export class UpdateUserEmailAddress extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    NewEmailAddress : string; 
  }
  
  export class UpdateUserGroup extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string; 
  }
  
  export class UpdateUserPhoneNumber extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    PhoneNumber : string; 
    Type : EVA.Core.PhoneNumberTypes; 
    Description : string; 
  }
  
  export class UpdateUserResponse extends EVA.API.ResponseMessage {
  }
  
  export class UpdateWishList extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    OrderID : number; // Int32
    Name : string; 
    Data : any; 
    SortedWishListLineIDs : number[]; 
  }
  
  export class OrderLedgerDtoUserDto {
    ID : number; // Int32
    FullName : string; 
  }
  
  export class UserGroupDto {
    ID : number; // Int32
    Name : string; 
  }
  
  export class UserPhoneNumberModel {
    ID : number; // Int32
    PhoneNumber : string; 
    Description : string; 
    Type : EVA.Core.PhoneNumberTypes; 
    IsPrimary : boolean; 
  }
  
  export class SearchUsersResponseUserSearchDto {
    ID : number; // Int32
    CompanyName : string; 
    BackendRelationID : string; 
    EmailAddress : string; 
    FirstName : string; 
    LastName : string; 
    FullName : string; 
    ShippingAddress : EVA.Core.AddressDto; 
    BillingAddress : EVA.Core.AddressDto; 
    Type : EVA.Framework.UserTypes; 
    PhoneNumber : string; 
    GravatarHash : string; 
    Data : { [ key : string ] : string }; 
    EmployeeNumber : string; 
    PrimaryOrganizationUnitID? : number; // Int32, nullable
    PrimaryOrganizationUnitName : string; 
  }
  
  export class ValidateExportSchedule extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ValidateExportScheduleResponse> {
    OrderID : number; // Int32
    OrderLineIDs : number[]; 
  }
  
  export class ValidateExportScheduleResponse extends EVA.API.ResponseMessage {
    ValidationResult : EVA.Core.OrderExportValidationResult; 
  }
  
  export class ValidatePeriodClosing extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ValidatePeriodClosingResponse> {
    WorkSet : EVA.Core.PeriodClosingWorkSet; 
  }
  
  export class ValidatePeriodClosingResponse extends EVA.API.ResponseMessage {
    ValidationErrors : { [ key : string ] : string[] }; 
  }
  
  export class ValidateRequiredDataForOrder extends EVA.API.RequestMessageGeneric<EVA.Core.Services.ValidateRequiredDataForOrderResponse> {
    OrderID : number; // Int32
    RequiredFor : EVA.Core.RequiredFor; 
  }
  
  export class ValidateRequiredDataForOrderResponse extends EVA.API.ResponseMessage {
    ValidatedData : EVA.Core.RequiredDataValidationResult; 
  }
  
  export class VerifyCustomer extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    VerificationCode : string; 
    ManualRelease : boolean; 
    IdentificationCode : string; 
  }
  
  export class VerifyEmailAddress extends EVA.API.RequestMessageGeneric<EVA.Core.Services.VerifyEmailAddressResponse> {
    Token : string; 
  }
  
  export class VerifyEmailAddressResponse extends EVA.API.ResponseMessage {
    Authentication : EVA.Framework.AuthenticationResults; 
    AuthenticationToken : string; 
  }
  
  export class VerifyOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
  }
  
  export class GetWebshopsResponseWebshopDto {
    ID : number; // Int32
    Name : string; 
    CountryID : string; 
  }
  
  export class WishListDto {
    ID : string; 
    Name : string; 
    Data : any; 
    IsCompleted : boolean; 
    Customer : EVA.Core.Services.WishListUserDto; 
    Lines : EVA.Core.Services.WishListLineDto[]; 
    Fundings : EVA.Core.Services.WishListFundingDto[]; 
    OrderID : number; // Int32
    AccessToken : string; 
  }
  
  export class WishListFundingDto {
    ID : number; // Int32
    Type : EVA.Core.WishListFundingType; 
    IsConfirmed : boolean; 
    Name : string; 
    Remark : string; 
    Amount : number; // Decimal
    CurrencyID : string; 
    Quantity? : number; // Int32, nullable
  }
  
  export class WishListLineDto {
    ID : number; // Int32
    Quantity : number; // Int32
    CurrencyID : string; 
    TotalAmount : number; // Decimal
    Product : EVA.Core.Services.WishListProductDto; 
    Fundings : EVA.Core.Services.WishListFundingDto[]; 
    UnitPrice : number; // Decimal
    FundedAmount : number; // Decimal
    FundedAmountAsPayment : number; // Decimal
    FundedQuantityAsPayment? : number; // Decimal, nullable
    FundedQuantityAsDelivery : number; // Int32
    OpenAmount : number; // Decimal
    OpenQuantity? : number; // Decimal, nullable
  }
  
  export class GetWishListOrderLineDataResponseWishListOrderLineDataDto {
    OrderID : number; // Int32
    OrderLineID : number; // Int32
    IsHidden : boolean; 
  }
  
  export class WishListPaymentTransactionDto {
    ID : number; // Int32
    Amount : number; // Decimal
    PaymentName : string; 
    CurrencyID : string; 
    ExchangeRate : number; // Decimal
    ForeignAmount : number; // Decimal
    Description : string; 
  }
  
  export class WishListProductDto {
    ID : number; // Int32
    BackendID : string; 
    CustomID : string; 
    Name : string; 
    Properties : any; 
  }
  
  export class WishListUserDto {
    ID : number; // Int32
    EmailAddress : string; 
    FullName : string; 
  }
  
  export class WrapLine {
    OrderLineID : number; // Int32
    Quantity : number; // Int32
  }
  
}