/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.Sidekick.Common {
  
  export class SidekickSyncUsersResponseUserDtoAuthenticationDataDto {
    Type : string; 
    Data : string; 
    SearchKey : string; 
  }
  
  export class SidekickSyncGeneralResponseCashHandlerDto {
    Name : string; 
    CurrencyID : string; 
    RoundingFactor : number; // Decimal
    Coins : number[]; 
    BankNotes : number[]; 
  }
  
  export class CurrencyInfo {
    ID : string; 
    Name : string; 
  }
  
  export class PushSidekickOrderCustomerDto {
    SidekickID : number; // Int32
    FirstName : string; 
    LastName : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
    LanguageID : string; 
    CountryID : string; 
    Gender : string; 
  }
  
  export class SidekickSyncGeneralResponseDeviceDto {
    ID : number; // Int32
    Name : string; 
    Types : string[]; 
    NetworkName : string; 
    IpAddress : string; 
    StationID? : number; // Int32, nullable
    AssemblyName : string; 
    EcrID : string; 
    HardwareID : string; 
    ProxyID : string; 
    ConnectionType : EVA.Core.ConnectionType; 
  }
  
  export class SidekickSyncUsersResponseUserDtoFunctionalityDto {
    Functionality : string; 
    FunctionalityScope : EVA.Framework.FunctionalityScope; 
    UserType : EVA.Framework.UserTypes; 
  }
  
  export class SidekickSyncGeneralResponseMessageTemplateDto {
    Name : string; 
    Type : EVA.Core.MessageTemplateTypes; 
    Template : string; 
    Helpers : string; 
    Destination : EVA.Core.MessageTemplateDestinations; 
    PaperProperties : EVA.Core.PaperProperties; 
    IsDisabled : boolean; 
  }
  
  export class PushSidekickOrderOrderLineDiscount {
    BackendID : string; 
    Description : string; 
    Amount : number; // Decimal
  }
  
  export class PushSidekickOrderOrderLineDto {
    ID : number; // Int32
    BackendID : string; 
    CustomID : string; 
    UnitPriceInTax : number; // Decimal
    TaxRate : number; // Decimal
    Quantity : number; // Int32
    Description : string; 
    Discounts : EVA.Sidekick.Common.PushSidekickOrderOrderLineDiscount[]; 
  }
  
  export class SidekickSyncGeneralResponseOrganizationUnitDto {
    BackendID : string; 
    Name : string; 
    Description : string; 
    CashHandler : EVA.Sidekick.Common.SidekickSyncGeneralResponseCashHandlerDto; 
    BackendRelationID : string; 
    BackendCompanyID : string; 
    BranchNumber : string; 
    GlobalLocationNumber : string; 
    Address : EVA.Core.AddressDataDto; 
    Status : EVA.Core.OrganizationUnitStatus; 
    Type : EVA.Framework.OrganizationUnitTypes; 
    Latitude? : number; // Double, nullable
    Longitude? : number; // Double, nullable
    Subnet : string; 
    IpAddress : string; 
    BankAccount : string; 
    CocNumber : string; 
    VatNumber : string; 
    RegistrationNumber : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
    UseForAccounting : boolean; 
    CountryID : string; 
    LanguageID : string; 
    CurrencyID : string; 
    CostPriceCurrencyID : string; 
    TimeZone : string; 
    AssortmentID : number; // Int32
  }
  
  export class PushSidekickOrderPaymentDto {
    BackendID : string; 
    Method : string; 
    Type : string; 
    Amount : number; // Decimal
    Data : string; 
    ID : number; // Int32
    ProxyID : string; 
  }
  
  export class SidekickSyncGeneralResponsePaymentTypeDto {
    Name : string; 
    Code : string; 
    IsRoundingType : boolean; 
    IncludeInCashJournal : boolean; 
    IsExternal : boolean; 
    LedgerClassID : string; 
    PrintOnDocuments : boolean; 
    BackendRelationID : string; 
    BookPaymentMethodInvoice : boolean; 
    CanBeUsedForAuthorization : boolean; 
    AutoFinalizeOnOrderPaid : boolean; 
  }
  
  export class SidekickSyncCatalogResponseProductDto {
    ID : number; // Int32
    BackendID : string; 
    BrandName : string; 
    CustomID : string; 
    Name : string; 
    Type : EVA.Core.ProductTypes; 
    BackendSystemID : string; 
    BackendStatus : string; 
    LogicalLevel : string; 
    ConfigurableProperty : string; 
    ConfigurablePropertyValue : string; 
    TaxCode : string; 
    _data : any; 
    Data : string; 
    UnitPriceInTax? : number; // Decimal, nullable
    Children : number[]; 
    HasParents : boolean; 
    Barcodes : string[]; 
    GiftCardType : string; 
    GiftCardData : string; 
  }
  
  export class PushSidekickOrder extends EVA.API.RequestMessageGeneric<EVA.Sidekick.Common.PushSidekickOrderResponse> {
    SidekickOrderID : string; 
    CreationTime? : string; // DateTime, nullable
    Remark : string; 
    Customer : EVA.Sidekick.Common.PushSidekickOrderCustomerDto; 
    ShippingAddress : EVA.Core.AddressDataDto; 
    BillingAddress : EVA.Core.AddressDataDto; 
    Lines : EVA.Sidekick.Common.PushSidekickOrderOrderLineDto[]; 
    Payments : EVA.Sidekick.Common.PushSidekickOrderPaymentDto[]; 
  }
  
  export class PushSidekickOrderResponse extends EVA.API.ResponseMessage {
    ID : number; // Int32
    AlreadyExists : boolean; 
  }
  
  export class SidekickSyncCatalog extends EVA.API.RequestMessageGeneric<EVA.Sidekick.Common.SidekickSyncCatalogResponse> {
  }
  
  export class SidekickSyncCatalogResponse extends EVA.API.ResponseMessage {
    Products : EVA.Sidekick.Common.SidekickSyncCatalogResponseProductDto[]; 
  }
  
  export class SidekickSyncGeneral extends EVA.API.RequestMessageGeneric<EVA.Sidekick.Common.SidekickSyncGeneralResponse> {
  }
  
  export class SidekickSyncGeneralResponse extends EVA.API.ResponseMessage {
    LedgerClasses : string[]; 
    Currencies : EVA.Sidekick.Common.CurrencyInfo[]; 
    OrganizationUnit : EVA.Sidekick.Common.SidekickSyncGeneralResponseOrganizationUnitDto; 
    Settings : { [ key : string ] : string }; 
    PaymentTypes : EVA.Sidekick.Common.SidekickSyncGeneralResponsePaymentTypeDto[]; 
    MessageTemplates : EVA.Sidekick.Common.SidekickSyncGeneralResponseMessageTemplateDto[]; 
    Stations : EVA.Sidekick.Common.SidekickSyncGeneralResponseStationDto[]; 
    Devices : EVA.Sidekick.Common.SidekickSyncGeneralResponseDeviceDto[]; 
  }
  
  export class SidekickSyncUsers extends EVA.API.RequestMessageGeneric<EVA.Sidekick.Common.SidekickSyncUsersResponse> {
  }
  
  export class SidekickSyncUsersResponse extends EVA.API.ResponseMessage {
    Users : EVA.Sidekick.Common.SidekickSyncUsersResponseUserDto[]; 
  }
  
  export class SidekickSyncGeneralResponseStationDto {
    ID : number; // Int32
    Name : string; 
    ProxyID : string; 
  }
  
  export class SidekickSyncUsersResponseUserDto {
    EmailAddress : string; 
    Nickname : string; 
    FirstName : string; 
    LastName : string; 
    LanguageID : string; 
    CountryID : string; 
    Type : EVA.Framework.UserTypes; 
    BackendSystemID : string; 
    BackendID : string; 
    TimeZone : string; 
    Functionalities : EVA.Sidekick.Common.SidekickSyncUsersResponseUserDtoFunctionalityDto[]; 
    AuthenticationData : EVA.Sidekick.Common.SidekickSyncUsersResponseUserDtoAuthenticationDataDto[]; 
  }
  
}